
;; Function posix_aio_flush (posix_aio_flush)

;; 1 loops found
;;
;; Loop 0
;;  header 0, latch 1
;;  depth 0, outer -1
;;  nodes: 0 1 2
;; 2 succs { 1 }
posix_aio_flush (void * opaque)
{
  struct PosixAioState * s;
  struct qemu_paiocb * D.7093;
  int D.7092;

<bb 2>:
  s_2 = (struct PosixAioState *) opaque_1(D);
  D.7093_3 = s_2->first_aio;
  D.7092_4 = D.7093_3 != 0B;
  return D.7092_4;

}



;; Function die2 (die2)

;; 1 loops found
;;
;; Loop 0
;;  header 0, latch 1
;;  depth 0, outer -1
;;  nodes: 0 1 2
;; 2 succs { }
die2 (int err, const char * what)
{
  struct FILE * restrict stderr.23;
  struct _IO_FILE * stderr.22;
  const char * restrict D.6724;
  char * D.6723;

<bb 2>:
  D.6723_2 = strerror (err_1(D));
  D.6724_3 = (const char * restrict) "%s failed: %s\n";
  stderr.22_4 = stderr;
  stderr.23_5 = (struct FILE * restrict) stderr.22_4;
  fprintf (stderr.23_5, D.6724_3, what_6(D), D.6723_2);
  abort ();

}



;; Function paio_init (paio_init)

;; 1 loops found
;;
;; Loop 0
;;  header 0, latch 1
;;  depth 0, outer -1
;;  nodes: 0 1 2 3 4 5 6 7 8 9 10
;; 2 succs { 10 3 }
;; 3 succs { 4 5 }
;; 4 succs { 10 }
;; 5 succs { 6 7 }
;; 6 succs { 7 }
;; 7 succs { 8 9 }
;; 8 succs { 9 }
;; 9 succs { 10 }
;; 10 succs { 1 }
paio_init ()
{
  int ret;
  int fds[2];
  struct PosixAioState * s;
  struct sigaction act;
  int D.7205;
  int D.7204;
  int D.7203;
  int D.7202;
  const char * restrict D.7201;
  struct FILE * restrict stderr.76;
  struct _IO_FILE * stderr.75;
  int D.7196;
  const struct sigaction * restrict act.74;
  void * D.7194;
  void * D.7193;
  struct PosixAioState * posix_aio_state.73;

<bb 2>:
  posix_aio_state.73_2 = posix_aio_state;
  if (posix_aio_state.73_2 != 0B)
    goto <bb 10>;
  else
    goto <bb 3>;

<bb 3>:
  D.7194_4 = qemu_malloc (12);
  s_5 = (struct PosixAioState *) D.7194_4;
  sigfillset (&act.sa_mask);
  act.sa_flags = 0;
  act.__sigaction_handler.sa_handler = aio_signal_handler;
  act.74_6 = (const struct sigaction * restrict) &act;
  sigaction (12, act.74_6, 0B);
  s_5->first_aio = 0B;
  D.7196_7 = pipe (&fds);
  if (D.7196_7 == -1)
    goto <bb 4>;
  else
    goto <bb 5>;

<bb 4>:
  stderr.75_8 = stderr;
  stderr.76_9 = (struct FILE * restrict) stderr.75_8;
  D.7201_10 = (const char * restrict) "failed to create pipe\n";
  __builtin_fwrite (D.7201_10, 1, 22, stderr.76_9);
  goto <bb 10>;

<bb 5>:
  D.7202_12 = fds[0];
  s_5->rfd = D.7202_12;
  D.7203_13 = fds[1];
  s_5->wfd = D.7203_13;
  fcntl (D.7202_12, 4, 2048);
  D.7205_15 = s_5->wfd;
  fcntl (D.7205_15, 4, 2048);
  D.7204_16 = s_5->rfd;
  qemu_aio_set_fd_handler (D.7204_16, posix_aio_read, 0B, posix_aio_flush, s_5);
  ret_17 = pthread_attr_init (&attr);
  if (ret_17 != 0)
    goto <bb 6>;
  else
    goto <bb 7>;

<bb 6>:
  die2 (ret_17, &"pthread_attr_init"[0]);

<bb 7>:
  ret_19 = pthread_attr_setdetachstate (&attr, 1);
  if (ret_19 != 0)
    goto <bb 8>;
  else
    goto <bb 9>;

<bb 8>:
  die2 (ret_19, &"pthread_attr_setdetachstate"[0]);

<bb 9>:
  request_list.tqh_first = 0B;
  request_list.tqh_last = &request_list.tqh_first;
  posix_aio_state = s_5;

<bb 10>:
  # D.7193_1 = PHI <posix_aio_state.73_2(2), 0B(4), s_5(9)>
  return D.7193_1;

}



;; Function die (die)

;; 1 loops found
;;
;; Loop 0
;;  header 0, latch 1
;;  depth 0, outer -1
;;  nodes: 0 1 2
;; 2 succs { 1 }
die (const char * what)
{
  int D.6731;
  int * D.6730;

<bb 2>:
  D.6730_1 = __errno_location ();
  D.6731_2 = *D.6730_1;
  die2 (D.6731_2, what_3(D));
  return;

}



;; Function aio_signal_handler (aio_signal_handler)

;; 1 loops found
;;
;; Loop 0
;;  header 0, latch 1
;;  depth 0, outer -1
;;  nodes: 0 1 2 3 4
;; 2 succs { 3 4 }
;; 3 succs { 4 }
;; 4 succs { 1 }
aio_signal_handler (int signum)
{
  char byte;
  int D.7102;
  struct PosixAioState * posix_aio_state.67;

<bb 2>:
  posix_aio_state.67_1 = posix_aio_state;
  if (posix_aio_state.67_1 != 0B)
    goto <bb 3>;
  else
    goto <bb 4>;

<bb 3>:
  byte = 0;
  D.7102_3 = posix_aio_state.67_1->wfd;
  write (D.7102_3, &byte, 1);

<bb 4>:
  qemu_service_io ();
  return;

}



;; Function handle_aiocb_rw_linear (handle_aiocb_rw_linear)

;; 2 loops found
;;
;; Loop 0
;;  header 0, latch 1
;;  depth 0, outer -1
;;  nodes: 0 1 2 3 4 5 6 7 8 9 10 11 12 13
;;
;; Loop 1
;;  header 12, latch 11
;;  depth 1, outer 0
;;  nodes: 12 11 7 10 9 6 4 5 3
;; 2 succs { 12 }
;; 3 succs { 4 5 }
;; 4 succs { 6 }
;; 5 succs { 6 }
;; 6 succs { 7 9 }
;; 7 succs { 11 8 }
;; 8 succs { 13 }
;; 9 succs { 13 10 }
;; 10 succs { 11 }
;; 11 succs { 12 }
;; 12 succs { 3 13 }
;; 13 succs { 1 }
handle_aiocb_rw_linear (struct qemu_paiocb * aiocb, char * buf)
{
  size_t len;
  size_t offset;
  int D.6881;
  int D.6877;
  int * D.6876;
  ssize_t D.6873;
  void * D.6872;
  ssize_t D.6870;
  int D.6869;
  const void * D.6868;
  size_t D.6867;
  size_t D.6866;
  off_t D.6865;
  off_t D.6864;
  off_t D.6863;
  int D.6860;
  int D.6859;

<bb 2>:
  goto <bb 12>;

<bb 3>:
  D.6859_7 = aiocb_5(D)->aio_type;
  D.6860_8 = D.6859_7 & 2;
  if (D.6860_8 != 0)
    goto <bb 4>;
  else
    goto <bb 5>;

<bb 4>:
  D.6863_9 = aiocb_5(D)->aio_offset;
  D.6864_10 = (off_t) offset_1;
  D.6865_11 = D.6863_9 + D.6864_10;
  D.6867_13 = D.6866_6 - offset_1;
  D.6868_15 = buf_14(D) + offset_1;
  D.6869_16 = aiocb_5(D)->aio_fildes;
  D.6870_17 = pwrite (D.6869_16, D.6868_15, D.6867_13, D.6865_11);
  len_18 = (size_t) D.6870_17;
  goto <bb 6>;

<bb 5>:
  D.6863_19 = aiocb_5(D)->aio_offset;
  D.6864_20 = (off_t) offset_1;
  D.6865_21 = D.6863_19 + D.6864_20;
  D.6867_23 = D.6866_6 - offset_1;
  D.6872_24 = buf_14(D) + offset_1;
  D.6869_25 = aiocb_5(D)->aio_fildes;
  D.6873_26 = pread (D.6869_25, D.6872_24, D.6867_23, D.6865_21);
  len_27 = (size_t) D.6873_26;

<bb 6>:
  # len_3 = PHI <len_18(4), len_27(5)>
  if (len_3 == 0x0ffffffff)
    goto <bb 7>;
  else
    goto <bb 9>;

<bb 7>:
  D.6876_28 = __errno_location ();
  D.6877_29 = *D.6876_28;
  if (D.6877_29 == 4)
    goto <bb 11>;
  else
    goto <bb 8>;

<bb 8>:
Invalid sum of incoming frequencies 1956, should be 268
  D.6876_30 = __errno_location ();
  D.6877_31 = *D.6876_30;
  D.6881_32 = -D.6877_31;
  offset_33 = (size_t) D.6881_32;
  goto <bb 13>;

<bb 9>:
Invalid sum of incoming frequencies 6984, should be 8671
  if (len_3 == 0)
    goto <bb 13>;
  else
    goto <bb 10>;

<bb 10>:
  offset_34 = offset_1 + len_3;

<bb 11>:
  # offset_35 = PHI <offset_1(7), offset_34(10)>

<bb 12>:
  # offset_1 = PHI <offset_35(11), 0(2)>
  D.6866_6 = aiocb_5(D)->aio_nbytes;
  if (D.6866_6 > offset_1)
    goto <bb 3>;
  else
    goto <bb 13>;

<bb 13>:
  # offset_2 = PHI <offset_33(8), offset_1(9), offset_1(12)>
  return offset_2;

}



;; Function mutex_unlock.clone.0 (mutex_unlock.clone.0)

;; 1 loops found
;;
;; Loop 0
;;  header 0, latch 1
;;  depth 0, outer -1
;;  nodes: 0 1 2 3 4
;; 2 succs { 3 4 }
;; 3 succs { 4 }
;; 4 succs { 1 }
mutex_unlock.clone.0 ()
{
  int ret;
  union pthread_mutex_t * mutex;

<bb 2>:
  ret_1 = pthread_mutex_unlock (&lock);
  if (ret_1 != 0)
    goto <bb 3>;
  else
    goto <bb 4>;

<bb 3>:
  die2 (ret_1, &"pthread_mutex_unlock"[0]);

<bb 4>:
  return;

}



;; Function mutex_lock.clone.1 (mutex_lock.clone.1)

;; 1 loops found
;;
;; Loop 0
;;  header 0, latch 1
;;  depth 0, outer -1
;;  nodes: 0 1 2 3 4
;; 2 succs { 3 4 }
;; 3 succs { 4 }
;; 4 succs { 1 }
mutex_lock.clone.1 ()
{
  int ret;
  union pthread_mutex_t * mutex;

<bb 2>:
  ret_1 = pthread_mutex_lock (&lock);
  if (ret_1 != 0)
    goto <bb 3>;
  else
    goto <bb 4>;

<bb 3>:
  die2 (ret_1, &"pthread_mutex_lock"[0]);

<bb 4>:
  return;

}



;; Function qemu_paio_submit (qemu_paio_submit)

;; 1 loops found
;;
;; Loop 0
;;  header 0, latch 1
;;  depth 0, outer -1
;;  nodes: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14
;; 2 succs { 3 12 }
;; 3 succs { 4 12 }
;; 4 succs { 5 6 }
;; 5 succs { 6 }
;; 6 succs { 7 8 }
;; 7 succs { 8 }
;; 8 succs { 9 10 }
;; 9 succs { 10 }
;; 10 succs { 11 12 }
;; 11 succs { 12 }
;; 12 succs { 13 14 }
;; 13 succs { 14 }
;; 14 succs { 1 }
qemu_paio_submit (struct qemu_paiocb * aiocb)
{
  int cur_threads.53;
  int cur_threads.54;
  int idle_threads.55;
  int idle_threads.56;
  int D.9241;
  const struct sigset_t * restrict set.57;
  int D.9239;
  const struct sigset_t * restrict oldset.58;
  int D.9237;
  struct sigset_t set;
  struct sigset_t oldset;
  int ret;
  const union pthread_attr_t * restrict attr.29;
  int ret;
  struct qemu_paiocb * * D.7028;
  struct qemu_paiocb * * D.7027;
  int cur_threads.60;
  int idle_threads.59;

<bb 2>:
  aiocb_1(D)->ret = -115;
  aiocb_1(D)->active = 0;
  mutex_lock.clone.1 ();
  idle_threads.59_2 = idle_threads;
  if (idle_threads.59_2 == 0)
    goto <bb 3>;
  else
    goto <bb 12>;

<bb 3>:
  cur_threads.60_3 = cur_threads;
  if (cur_threads.60_3 <= 63)
    goto <bb 4>;
  else
    goto <bb 12>;

<bb 4>:
  cur_threads.54_10 = cur_threads.60_3 + 1;
  cur_threads = cur_threads.54_10;
  idle_threads = 1;
  D.9241_13 = sigfillset (&set);
  if (D.9241_13 != 0)
    goto <bb 5>;
  else
    goto <bb 6>;

<bb 5>:
  die (&"sigfillset"[0]);

<bb 6>:
  set.57_14 = (const struct sigset_t * restrict) &set;
  D.9239_15 = sigprocmask (2, set.57_14, &oldset);
  if (D.9239_15 != 0)
    goto <bb 7>;
  else
    goto <bb 8>;

<bb 7>:
  die (&"sigprocmask"[0]);

<bb 8>:
  attr.29_16 = (const union pthread_attr_t * restrict) &attr;
  ret_17 = pthread_create (&thread_id, attr.29_16, aio_thread, 0B);
  if (ret_17 != 0)
    goto <bb 9>;
  else
    goto <bb 10>;

<bb 9>:
  die2 (ret_17, &"pthread_create"[0]);

<bb 10>:
  oldset.58_18 = (const struct sigset_t * restrict) &oldset;
  D.9237_19 = sigprocmask (2, oldset.58_18, 0B);
  if (D.9237_19 != 0)
    goto <bb 11>;
  else
    goto <bb 12>;

<bb 11>:
  die (&"sigprocmask restore"[0]);

<bb 12>:
  aiocb_1(D)->node.tqe_next = 0B;
  D.7027_5 = request_list.tqh_last;
  aiocb_1(D)->node.tqe_prev = D.7027_5;
  D.7027_6 = request_list.tqh_last;
  *D.7027_6 = aiocb_1(D);
  D.7028_7 = &aiocb_1(D)->node.tqe_next;
  request_list.tqh_last = D.7028_7;
  mutex_unlock.clone.0 ();
  ret_8 = pthread_cond_signal (&cond);
  if (ret_8 != 0)
    goto <bb 13>;
  else
    goto <bb 14>;

<bb 13>:
  die2 (ret_8, &"pthread_cond_signal"[0]);

<bb 14>:
  return;

}



;; Function paio_ioctl (paio_ioctl)

;; 1 loops found
;;
;; Loop 0
;;  header 0, latch 1
;;  depth 0, outer -1
;;  nodes: 0 1 2 3 4
;; 2 succs { 4 3 }
;; 3 succs { 4 }
;; 4 succs { 1 }
paio_ioctl (struct BlockDriverState * bs, int fd, long unsigned int req, void * buf, void (*<T122d>) (void *, int) cb, void * opaque)
{
  struct qemu_paiocb * acb;
  struct qemu_paiocb * D.7182;
  struct PosixAioState * posix_aio_state.72;
  struct BlockDriverAIOCB * D.7180;
  void * D.7177;

<bb 2>:
  D.7177_5 = qemu_aio_get (&raw_aio_pool, bs_2(D), cb_3(D), opaque_4(D));
  acb_6 = (struct qemu_paiocb *) D.7177_5;
  if (acb_6 == 0B)
    goto <bb 4>;
  else
    goto <bb 3>;

<bb 3>:
  acb_6->aio_type = 4;
  acb_6->aio_fildes = fd_8(D);
  acb_6->ev_signo = 12;
  acb_6->aio_offset = 0;
  acb_6->D.6689.aio_ioctl_buf = buf_9(D);
  acb_6->aio_nbytes = req_10(D);
  posix_aio_state.72_11 = posix_aio_state;
  D.7182_12 = posix_aio_state.72_11->first_aio;
  acb_6->next = D.7182_12;
  posix_aio_state.72_11->first_aio = acb_6;
  qemu_paio_submit (acb_6);
  D.7180_14 = &acb_6->common;

<bb 4>:
  # D.7180_1 = PHI <0B(2), D.7180_14(3)>
  return D.7180_1;

}



;; Function paio_submit (paio_submit)

;; 1 loops found
;;
;; Loop 0
;;  header 0, latch 1
;;  depth 0, outer -1
;;  nodes: 0 1 2 3 4 5 6
;; 2 succs { 6 3 }
;; 3 succs { 4 5 }
;; 4 succs { 5 }
;; 5 succs { 6 }
;; 6 succs { 1 }
paio_submit (struct BlockDriverState * bs, void * aio_ctx, int fd, int64_t sector_num, struct QEMUIOVector * qiov, int nb_sectors, void (*<T122d>) (void *, int) cb, void * opaque, int type)
{
  struct qemu_paiocb * acb;
  struct qemu_paiocb * D.7167;
  struct PosixAioState * posix_aio_state.71;
  int64_t D.7165;
  size_t D.7164;
  int D.7163;
  int D.7162;
  struct iovec * D.7161;
  struct BlockDriverAIOCB * D.7158;
  void * D.7155;

<bb 2>:
  D.7155_5 = qemu_aio_get (&raw_aio_pool, bs_2(D), cb_3(D), opaque_4(D));
  acb_6 = (struct qemu_paiocb *) D.7155_5;
  if (acb_6 == 0B)
    goto <bb 6>;
  else
    goto <bb 3>;

<bb 3>:
  acb_6->aio_type = type_8(D);
  acb_6->aio_fildes = fd_9(D);
  acb_6->ev_signo = 12;
  if (qiov_10(D) != 0B)
    goto <bb 4>;
  else
    goto <bb 5>;

<bb 4>:
  D.7161_11 = qiov_10(D)->iov;
  acb_6->D.6689.aio_iov = D.7161_11;
  D.7162_12 = qiov_10(D)->niov;
  acb_6->aio_niov = D.7162_12;

<bb 5>:
  D.7163_14 = nb_sectors_13(D) * 512;
  D.7164_15 = (size_t) D.7163_14;
  acb_6->aio_nbytes = D.7164_15;
  D.7165_17 = sector_num_16(D) * 512;
  acb_6->aio_offset = D.7165_17;
  posix_aio_state.71_18 = posix_aio_state;
  D.7167_19 = posix_aio_state.71_18->first_aio;
  acb_6->next = D.7167_19;
  posix_aio_state.71_18->first_aio = acb_6;
  qemu_paio_submit (acb_6);
  D.7158_21 = &acb_6->common;

<bb 6>:
  # D.7158_1 = PHI <0B(2), D.7158_21(5)>
  return D.7158_1;

}



;; Function aio_thread (aio_thread)

;; 7 loops found
;;
;; Loop 0
;;  header 0, latch 1
;;  depth 0, outer -1
;;  nodes: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 48 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 47 44 45 46
;;
;; Loop 1
;;  header 3, latch 44
;;  depth 1, outer 0
;;  nodes: 3 44 43 36 38 41 42 40 37 13 11 12 10 9 8 4 7 5 6 47 39 16 25 35 31 34 32 33 27 30 28 29 14 17 26 15 46 24 22 20 21 19 18 48 23
;;
;; Loop 2
;;  header 4, latch 47
;;  depth 2, outer 1
;;  nodes: 4 47 43 36 38 41 42 40 37 13 11 12 10 9 8 7 5 6 39 16 25 35 31 34 32 33 27 30 28 29 14 17 26 15 46 24 22 20 21 19 18 48 23
;;
;; Loop 6
;;  header 34, latch 33
;;  depth 3, outer 2
;;  nodes: 34 33
;;
;; Loop 5
;;  header 30, latch 29
;;  depth 3, outer 2
;;  nodes: 30 29
;;
;; Loop 4
;;  header 19, latch 48
;;  depth 3, outer 2
;;  nodes: 19 48 23 22 20 21
;;
;; Loop 3
;;  header 8, latch 7
;;  depth 3, outer 2
;;  nodes: 8 7 5 6
;; 2 succs { 3 }
;; 3 succs { 4 }
;; 4 succs { 8 }
;; 5 succs { 6 7 }
;; 6 succs { 7 }
;; 7 succs { 8 }
;; 8 succs { 5 9 }
;; 9 succs { 45 10 }
;; 10 succs { 11 12 }
;; 11 succs { 13 }
;; 12 succs { 13 }
;; 13 succs { 42 14 39 37 }
;; 14 succs { 15 27 }
;; 15 succs { 16 17 }
;; 16 succs { 36 }
;; 17 succs { 18 27 }
;; 18 succs { 19 }
;; 19 succs { 20 21 }
;; 20 succs { 22 }
;; 21 succs { 22 }
;; 22 succs { 23 24 }
;; 23 succs { 48 46 }
;; 48 succs { 19 }
;; 24 succs { 25 }
;; 25 succs { 36 26 }
;; 26 succs { 27 }
;; 27 succs { 28 31 }
;; 28 succs { 30 }
;; 29 succs { 30 }
;; 30 succs { 29 31 }
;; 31 succs { 32 35 }
;; 32 succs { 34 }
;; 33 succs { 34 }
;; 34 succs { 33 35 }
;; 35 succs { 36 }
;; 36 succs { 43 }
;; 37 succs { 38 43 }
;; 38 succs { 43 }
;; 39 succs { 40 41 }
;; 40 succs { 43 }
;; 41 succs { 43 }
;; 42 succs { 43 }
;; 43 succs { 44 47 }
;; 47 succs { 4 }
;; 44 succs { 3 }
;; 45 succs { 1 }
;; 46 succs { 25 }

SSA replacement table
N_i -> { O_1 ... O_j } means that N_i replaces O_1, ..., O_j

ts_18 -> { ts_228 }
MPT.367_73 -> { MPT.367_242 }
i_123 -> { i_135 }
D.9350_124 -> { D.9350_157 }
copy_147 -> { copy_140 }
p_152 -> { p_151 }
tv_418 -> { tv_214 }
i_420 -> { i_135 }
request_list_427 -> { request_list_200 }
cond_428 -> { cond_186 }
p_429 -> { p_151 }
copy_430 -> { copy_140 }
D.9348_431 -> { D.9348_159 }
D.9349_432 -> { D.9349_158 }
stderr_433 -> { stderr_172 }
D.9368_434 -> { D.9368_156 }
ts_435 -> { ts_228 }
cond_436 -> { cond_186 }
tv_437 -> { tv_214 }
stderr_438 -> { stderr_172 }
request_list_439 -> { request_list_200 }
MPT.367_440 -> { MPT.367_242 }

Number of virtual NEW -> OLD mappings:      12
Number of real NEW -> OLD mappings:         10
Number of total NEW -> OLD mappings:        22

Number of virtual symbols: 12


Incremental SSA update started at block: 31

Number of blocks in CFG: 50
Number of blocks to update: 4 (  8%)




SSA replacement table
N_i -> { O_1 ... O_j } means that N_i replaces O_1, ..., O_j

p_15 -> { p_121 }
D.9368_27 -> { D.9368_129 }
tv_118 -> { tv_212 }
p_119 -> { p_121 }
i_145 -> { i_111 }
cond_421 -> { cond_184 }
stderr_422 -> { stderr_170 }
request_list_423 -> { request_list_198 }
i_424 -> { i_111 }
MPT.367_425 -> { MPT.367_240 }
ts_426 -> { ts_226 }
stderr_441 -> { stderr_170 }
cond_442 -> { cond_184 }
request_list_443 -> { request_list_198 }
tv_444 -> { tv_212 }
ts_445 -> { ts_226 }
MPT.367_446 -> { MPT.367_240 }

Number of virtual NEW -> OLD mappings:      12
Number of real NEW -> OLD mappings:          5
Number of total NEW -> OLD mappings:        17

Number of virtual symbols: 12


Incremental SSA update started at block: 27

Number of blocks in CFG: 53
Number of blocks to update: 4 (  8%)




SSA replacement table
N_i -> { O_1 ... O_j } means that N_i replaces O_1, ..., O_j

ret_447 -> { ret_1 }
stderr_448 -> { stderr_166 }
cond_449 -> { cond_180 }
request_list_450 -> { request_list_194 }
tv_451 -> { tv_208 }
ts_452 -> { ts_222 }
MPT.367_453 -> { MPT.367_236 }
D.6968_454 -> { D.6968_9 }
D.6969_455 -> { D.6969_10 }
D.6970_456 -> { D.6970_11 }
D.6971_457 -> { D.6971_12 }
stderr_458 -> { stderr_166 }
stderr_459 -> { stderr_166 }
cond_460 -> { cond_180 }
cond_461 -> { cond_180 }
request_list_462 -> { request_list_194 }
request_list_463 -> { request_list_194 }
tv_464 -> { tv_208 }
tv_465 -> { tv_208 }
ts_466 -> { ts_222 }
ts_467 -> { ts_222 }
MPT.367_468 -> { MPT.367_236 }
MPT.367_469 -> { MPT.367_236 }

Number of virtual NEW -> OLD mappings:      18
Number of real NEW -> OLD mappings:          5
Number of total NEW -> OLD mappings:        23

Number of virtual symbols: 18


Incremental SSA update started at block: 55

Number of blocks in CFG: 56
Number of blocks to update: 9 ( 16%)



Merging blocks 4 and 55
Merging blocks 7 and 8
Merging blocks 28 and 52
Merging blocks 29 and 30
Merging blocks 32 and 49
Merging blocks 33 and 34
Removing basic block 47
Removing basic block 48
Removing basic block 50
Removing basic block 51
Removing basic block 53
Removing basic block 54
Removing basic block 56
Removing basic block 57
aio_thread (void * unused)
{
  int D.9370;
  int D.9369;
  int D.9368;
  struct iovec * D.9367;
  void * D.9366;
  char * D.9365;
  int preadv_present.35;
  size_t D.9363;
  void * D.9362;
  int D.9361;
  unsigned int i.37;
  unsigned int D.9359;
  struct iovec * D.9358;
  size_t D.9357;
  void * D.9356;
  unsigned int i.39;
  unsigned int D.9354;
  struct iovec * D.9353;
  size_t D.9352;
  void * D.9351;
  _Bool D.9350;
  _Bool D.9349;
  _Bool D.9348;
  int i;
  char * p;
  size_t copy;
  int i;
  __off_t D.9347;
  __off_t D.9346;
  ssize_t len;
  int D.9345;
  int D.9344;
  int * D.9343;
  int D.9342;
  struct iovec * D.9341;
  int D.9340;
  off_t D.9339;
  int D.9338;
  int D.9337;
  void * D.9020;
  size_t D.9019;
  int D.9018;
  int * D.9016;
  int D.9015;
  int D.9014;
  int ret;
  int D.9010;
  int * D.9008;
  int D.9007;
  int D.9006;
  int ret;
  const struct timespec * restrict ts.26;
  _Bool D.9001;
  _Bool D.9000;
  _Bool D.8999;
  int ret;
  struct timespec ts;
  struct qemu_timeval tv;
  size_t ret;
  struct qemu_paiocb * aiocb;
  pid_t pid;
  int cur_threads.52;
  int cur_threads.51;
  int D.6991;
  int D.6990;
  int idle_threads.50;
  ssize_t ret.49;
  struct FILE * restrict stderr.48;
  struct _IO_FILE * stderr.47;
  const char * restrict D.6985;
  int D.6981;
  int D.6980;
  int idle_threads.43;
  int idle_threads.42;
  struct qemu_paiocb * * D.6976;
  struct qemu_paiocb * D.6973;
  _Bool D.6971;
  _Bool D.6970;
  _Bool D.6969;
  struct qemu_paiocb * D.6968;
  long int D.6966;
  __time_t D.6965;
  struct timeval * restrict tv.41;

<bb 2>:
  pid_3 = getpid ();

<bb 3>:

<bb 4>:
  tv.41_6 = (struct timeval * restrict) &tv;
  gettimeofday (tv.41_6, 0B);
  D.6965_7 = tv.tv_sec;
  D.6966_8 = D.6965_7 + 10;
  ts.tv_sec = D.6966_8;
  ts.tv_nsec = 0;
  mutex_lock.clone.1 ();
  D.6968_454 = request_list.tqh_first;
  D.6969_455 = D.6968_454 == 0B;
  D.6970_456 = 1;
  D.6971_457 = D.6969_455 & D.6970_456;
  if (D.6971_457 != 0)
    goto <bb 5>;
  else
    goto <bb 8>;

<bb 5>:
  ts.26_48 = (const struct timespec * restrict) &ts;
  ret_49 = pthread_cond_timedwait (&cond, &lock, ts.26_48);
  D.9001_50 = ret_49 != 0;
  D.9000_51 = ret_49 != 110;
  D.8999_52 = D.9001_50 & D.9000_51;
  if (D.8999_52 != 0)
    goto <bb 6>;
  else
    goto <bb 7>;

<bb 6>:
  die2 (ret_49, &"pthread_cond_timedwait"[0]);

<bb 7>:
  ret_14 = (size_t) ret_49;
  D.6968_9 = request_list.tqh_first;
  D.6969_10 = D.6968_9 == 0B;
  D.6970_11 = ret_14 != 110;
  D.6971_12 = D.6969_10 & D.6970_11;
  if (D.6971_12 != 0)
    goto <bb 5>;
  else
    goto <bb 8>;

<bb 8>:
  # D.6968_116 = PHI <D.6968_9(7), D.6968_454(4)>
  if (D.6968_116 == 0B)
    goto <bb 42>;
  else
    goto <bb 9>;

<bb 9>:
  aiocb_16 = D.6968_116;
  D.6973_17 = D.6968_116->node.tqe_next;
  if (D.6973_17 != 0B)
    goto <bb 10>;
  else
    goto <bb 11>;

<bb 10>:
  D.6976_19 = aiocb_16->node.tqe_prev;
  D.6973_17->node.tqe_prev = D.6976_19;
  goto <bb 12>;

<bb 11>:
  D.6976_20 = aiocb_16->node.tqe_prev;
  request_list.tqh_last = D.6976_20;

<bb 12>:
  D.6976_21 = aiocb_16->node.tqe_prev;
  D.6973_22 = aiocb_16->node.tqe_next;
  *D.6976_21 = D.6973_22;
  aiocb_16->active = 1;
  idle_threads.42_23 = idle_threads;
  idle_threads.43_24 = idle_threads.42_23 + -1;
  idle_threads = idle_threads.43_24;
  mutex_unlock.clone.0 ();
  D.6980_25 = aiocb_16->aio_type;
  D.6981_26 = D.6980_25 & 15;
  switch (D.6981_26) <default: <L12>, case 1 ... 2: <L20>, case 4: <L19>, case 8: <L18>>

<L20>:
  D.9369_74 = D.6980_25 & 4096;
  if (D.9369_74 == 0)
    goto <bb 14>;
  else
    goto <bb 26>;

<bb 14>:
  D.9368_75 = aiocb_16->aio_niov;
  if (D.9368_75 == 1)
    goto <bb 15>;
  else
    goto <bb 16>;

<bb 15>:
  D.9367_76 = aiocb_16->D.6689.aio_iov;
  D.9366_77 = D.9367_76->iov_base;
  D.9365_78 = (char *) D.9366_77;
  ret_79 = handle_aiocb_rw_linear (aiocb_16, D.9365_78);
  goto <bb 33>;

<bb 16>:
  preadv_present.35_80 = preadv_present;
  if (preadv_present.35_80 != 0)
    goto <bb 17>;
  else
    goto <bb 26>;

<bb 17>:

<bb 18>:
  D.9337_81 = aiocb_16->aio_type;
  D.9338_82 = D.9337_81 & 2;
  if (D.9338_82 != 0)
    goto <bb 19>;
  else
    goto <bb 20>;

<bb 19>:
  D.9339_83 = aiocb_16->aio_offset;
  D.9340_84 = aiocb_16->aio_niov;
  D.9341_85 = aiocb_16->D.6689.aio_iov;
  D.9342_86 = aiocb_16->aio_fildes;
  D.9346_87 = (__off_t) D.9339_83;
  len_88 = pwritev (D.9342_86, D.9341_85, D.9340_84, D.9346_87);
  goto <bb 21>;

<bb 20>:
  D.9339_89 = aiocb_16->aio_offset;
  D.9340_90 = aiocb_16->aio_niov;
  D.9341_91 = aiocb_16->D.6689.aio_iov;
  D.9342_92 = aiocb_16->aio_fildes;
  D.9347_93 = (__off_t) D.9339_89;
  len_94 = preadv (D.9342_92, D.9341_91, D.9340_90, D.9347_93);

<bb 21>:
  # len_95 = PHI <len_88(19), len_94(20)>
  if (len_95 == -1)
    goto <bb 22>;
  else
    goto <bb 23>;

<bb 22>:
  D.9343_96 = __errno_location ();
  D.9344_97 = *D.9343_96;
  if (D.9344_97 == 4)
    goto <bb 18>;
  else
    goto <bb 43>;

<bb 23>:
  # len_117 = PHI <len_95(21)>
  ret_102 = (size_t) len_117;

<bb 24>:
  # ret_104 = PHI <ret_101(43), ret_102(23)>
  D.9363_103 = aiocb_16->aio_nbytes;
  if (D.9363_103 == ret_104)
    goto <bb 33>;
  else
    goto <bb 25>;

<bb 25>:
  preadv_present = 0;

<bb 26>:
  D.9363_105 = aiocb_16->aio_nbytes;
  D.9362_106 = qemu_memalign (512, D.9363_105);
  p_107 = (char *) D.9362_106;
  D.9370_108 = aiocb_16->aio_type;
  D.9361_109 = D.9370_108 & 2;
  if (D.9361_109 != 0)
    goto <bb 27>;
  else
    goto <bb 29>;

<bb 27>:
  # p_146 = PHI <p_107(26)>
  D.9368_27 = aiocb_16->aio_niov;
  if (D.9368_27 > 0)
    goto <bb 28>;
  else
    goto <bb 29>;

<bb 28>:
  # i_145 = PHI <i_128(28), 0(27)>
  # p_15 = PHI <p_127(28), p_146(27)>
  D.9367_110 = aiocb_16->D.6689.aio_iov;
  i.37_112 = (unsigned int) i_145;
  D.9359_113 = i.37_112 * 8;
  D.9358_114 = D.9367_110 + D.9359_113;
  D.9357_115 = D.9358_114->iov_len;
  D.9356_120 = D.9358_114->iov_base;
  memcpy (p_15, D.9356_120, D.9357_115);
  D.9367_122 = aiocb_16->D.6689.aio_iov;
  D.9358_125 = D.9367_122 + D.9359_113;
  D.9357_126 = D.9358_125->iov_len;
  p_127 = p_15 + D.9357_126;
  i_128 = i_145 + 1;
  D.9368_129 = aiocb_16->aio_niov;
  if (i_128 < D.9368_129)
    goto <bb 28>;
  else
    goto <bb 29>;

<bb 29>:
  ret_130 = handle_aiocb_rw_linear (aiocb_16, p_107);
  D.9370_131 = aiocb_16->aio_type;
  D.9361_132 = D.9370_131 & 2;
  if (D.9361_132 == 0)
    goto <bb 30>;
  else
    goto <bb 32>;

<bb 30>:
  copy_133 = aiocb_16->aio_nbytes;
  D.9368_434 = aiocb_16->aio_niov;
  D.9350_124 = D.9368_434 > 0;
  D.9349_432 = copy_133 != 0;
  D.9348_431 = D.9350_124 & D.9349_432;
  if (D.9348_431 != 0)
    goto <bb 31>;
  else
    goto <bb 32>;

<bb 31>:
  # i_123 = PHI <i_155(31), 0(30)>
  # copy_430 = PHI <copy_154(31), copy_133(30)>
  # p_429 = PHI <p_153(31), p_107(30)>
  D.9367_134 = aiocb_16->D.6689.aio_iov;
  i.39_136 = (unsigned int) i_123;
  D.9354_137 = i.39_136 * 8;
  D.9353_138 = D.9367_134 + D.9354_137;
  D.9352_139 = D.9353_138->iov_len;
  copy_419 = MIN_EXPR <copy_430, D.9352_139>;
  D.9351_150 = D.9353_138->iov_base;
  memcpy (D.9351_150, p_429, copy_419);
  p_153 = p_429 + copy_419;
  copy_154 = copy_430 - copy_419;
  i_155 = i_123 + 1;
  D.9368_156 = aiocb_16->aio_niov;
  D.9350_157 = i_155 < D.9368_156;
  D.9349_158 = copy_154 != 0;
  D.9348_159 = D.9350_157 & D.9349_158;
  if (D.9348_159 != 0)
    goto <bb 31>;
  else
    goto <bb 32>;

<bb 32>:
  qemu_vfree (p_107);

<bb 33>:
  # ret_160 = PHI <ret_79(15), D.9363_103(24), ret_130(32)>
  goto <bb 40>;

<L18>:
  D.9010_53 = aiocb_16->aio_fildes;
  ret_54 = qemu_fdatasync (D.9010_53);
  if (ret_54 == -1)
    goto <bb 35>;
  else
    goto <bb 40>;

<bb 35>:
  D.9008_55 = __errno_location ();
  D.9007_56 = *D.9008_55;
  D.9006_57 = -D.9007_56;
  ret_58 = (size_t) D.9006_57;
  goto <bb 40>;

<L19>:
  D.9020_60 = aiocb_16->D.6689.aio_ioctl_buf;
  D.9019_61 = aiocb_16->aio_nbytes;
  D.9018_62 = aiocb_16->aio_fildes;
  ret_63 = ioctl (D.9018_62, D.9019_61, D.9020_60);
  if (ret_63 == -1)
    goto <bb 37>;
  else
    goto <bb 38>;

<bb 37>:
  D.9016_64 = __errno_location ();
  D.9015_65 = *D.9016_64;
  D.9014_66 = -D.9015_65;
  ret_67 = (size_t) D.9014_66;
  goto <bb 40>;

<bb 38>:
  ret_68 = aiocb_16->aio_nbytes;
  goto <bb 40>;

<L12>:
  D.6985_34 = (const char * restrict) "invalid aio request (0x%x)\n";
  stderr.47_35 = stderr;
  stderr.48_36 = (struct FILE * restrict) stderr.47_35;
  fprintf (stderr.48_36, D.6985_34, D.6980_25);

<bb 40>:
  # ret_2 = PHI <ret_160(33), ret_58(35), ret_68(38), 0x0ffffffea(39), ret_67(37), 0(34)>
  mutex_lock.clone.1 ();
  ret.49_38 = (ssize_t) ret_2;
  aiocb_16->ret = ret.49_38;
  idle_threads.42_39 = idle_threads;
  idle_threads.50_40 = idle_threads.42_39 + 1;
  idle_threads = idle_threads.50_40;
  mutex_unlock.clone.0 ();
  D.6990_41 = aiocb_16->ev_signo;
  D.6991_42 = kill (pid_3, D.6990_41);
  if (D.6991_42 != 0)
    goto <bb 41>;
  else
    goto <bb 4>;

<bb 41>:
  die (&"kill failed"[0]);
  goto <bb 3>;

<bb 42>:
  idle_threads.42_43 = idle_threads;
  idle_threads.43_44 = idle_threads.42_43 + -1;
  idle_threads = idle_threads.43_44;
  cur_threads.51_45 = cur_threads;
  cur_threads.52_46 = cur_threads.51_45 + -1;
  cur_threads = cur_threads.52_46;
  mutex_unlock.clone.0 ();
  return 0B;

<bb 43>:
  D.9343_98 = __errno_location ();
  D.9344_99 = *D.9343_98;
  D.9345_100 = -D.9344_99;
  ret_101 = (size_t) D.9345_100;
  goto <bb 24>;

}



;; Function qemu_paio_error (qemu_paio_error)

;; 1 loops found
;;
;; Loop 0
;;  header 0, latch 1
;;  depth 0, outer -1
;;  nodes: 0 1 2 3 4
;; 2 succs { 3 4 }
;; 3 succs { 4 }
;; 4 succs { 1 }
qemu_paio_error (struct qemu_paiocb * aiocb)
{
  ssize_t ret;

<bb 2>:
  mutex_lock.clone.1 ();
  ret_8 = aiocb_2(D)->ret;
  mutex_unlock.clone.0 ();
  if (ret_8 < 0)
    goto <bb 3>;
  else
    goto <bb 4>;

<bb 3>:
  ret_5 = -ret_8;

<bb 4>:
  # ret_1 = PHI <ret_5(3), 0(2)>
  return ret_1;

}



;; Function posix_aio_read (posix_aio_read)

;; 4 loops found
;;
;; Loop 0
;;  header 0, latch 1
;;  depth 0, outer -1
;;  nodes: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20
;;
;; Loop 2
;;  header 8, latch 18
;;  depth 1, outer 0
;;  nodes: 8 18 16 17 15 14 13 11 10 9 19 12
;;
;; Loop 3
;;  header 10, latch 9
;;  depth 2, outer 2
;;  nodes: 10 9 19 12 11 13
;;
;; Loop 1
;;  header 4, latch 3
;;  depth 1, outer 0
;;  nodes: 4 3 5 6
;; 2 succs { 4 }
;; 3 succs { 4 }
;; 4 succs { 5 6 }
;; 5 succs { 3 7 }
;; 6 succs { 3 7 }
;; 7 succs { 8 }
;; 8 succs { 10 }
;; 9 succs { 10 }
;; 10 succs { 20 11 }
;; 11 succs { 12 13 }
;; 12 succs { 9 }
;; 13 succs { 14 19 }
;; 14 succs { 15 17 }
;; 15 succs { 18 16 }
;; 16 succs { 18 }
;; 17 succs { 18 }
;; 18 succs { 8 }
;; 19 succs { 9 }
;; 20 succs { 1 }
posix_aio_read (void * opaque)
{
  char bytes[16];
  ssize_t len;
  int ret;
  struct qemu_paiocb * * pacb;
  struct qemu_paiocb * acb;
  struct PosixAioState * s;
  void * D.7087;
  void (*<T122d>) (void *, int) D.7086;
  size_t D.7081;
  size_t ret.66;
  struct qemu_paiocb * D.7073;
  int D.7064;
  int * D.7063;
  int D.7059;

<bb 2>:
  s_4 = (struct PosixAioState *) opaque_3(D);
  goto <bb 4>;

<bb 3>:

<bb 4>:
  D.7059_5 = s_4->rfd;
  len_6 = read (D.7059_5, &bytes, 16);
  if (len_6 == -1)
    goto <bb 5>;
  else
    goto <bb 6>;

<bb 5>:
  D.7063_8 = __errno_location ();
  D.7064_9 = *D.7063_8;
  if (D.7064_9 == 4)
    goto <bb 3>;
  else
    goto <bb 7>;

<bb 6>:
  if (len_6 == 16)
    goto <bb 3>;
  else
    goto <bb 7>;

<bb 7>:

<bb 8>:
  pacb_10 = &s_4->first_aio;
  goto <bb 10>;

<bb 9>:
  # pacb_38 = PHI <pacb_25(19), pacb_1(12)>

<bb 10>:
  # pacb_1 = PHI <pacb_38(9), pacb_10(8)>
  acb_11 = *pacb_1;
  if (acb_11 == 0B)
    goto <bb 20> (the_end);
  else
    goto <bb 11>;

<bb 11>:
  ret_12 = qemu_paio_error (acb_11);
  if (ret_12 == 125)
    goto <bb 12>;
  else
    goto <bb 13>;

<bb 12>:
  D.7073_14 = acb_11->next;
  *pacb_1 = D.7073_14;
  qemu_aio_release (acb_11);
  goto <bb 9>;

<bb 13>:
  if (ret_12 != 115)
    goto <bb 14>;
  else
    goto <bb 19>;

<bb 14>:
  # pacb_79 = PHI <pacb_1(13)>
  # acb_80 = PHI <acb_11(13)>
  # ret_81 = PHI <ret_12(13)>
  if (ret_81 == 0)
    goto <bb 15>;
  else
    goto <bb 17>;

<bb 15>:
  mutex_lock.clone.1 ();
  ret_26 = acb_80->ret;
  mutex_unlock.clone.0 ();
  ret.66_17 = (size_t) ret_26;
  D.7081_18 = acb_80->aio_nbytes;
  if (ret.66_17 == D.7081_18)
    goto <bb 18>;
  else
    goto <bb 16>;

<bb 16>:
  goto <bb 18>;

<bb 17>:
  ret_21 = -ret_81;

<bb 18>:
  # ret_2 = PHI <-22(16), ret_21(17), 0(15)>
  D.7073_22 = acb_80->next;
  *pacb_79 = D.7073_22;
  D.7086_23 = acb_80->common.cb;
  D.7087_24 = acb_80->common.opaque;
  D.7086_23 (D.7087_24, ret_2);
  qemu_aio_release (acb_80);
  goto <bb 8>;

<bb 19>:
  pacb_25 = &acb_11->next;
  goto <bb 9>;

the_end:
  return;

}



;; Function paio_cancel (paio_cancel)

;; 3 loops found
;;
;; Loop 0
;;  header 0, latch 1
;;  depth 0, outer -1
;;  nodes: 0 1 2 3 4 5 6 7 8 18 9 10 11 12 13 14 15 16 17
;;
;; Loop 2
;;  header 11, latch 15
;;  depth 1, outer 0
;;  nodes: 11 15 13
;;
;; Loop 1
;;  header 9, latch 18
;;  depth 1, outer 0
;;  nodes: 9 18
;; 2 succs { 3 7 }
;; 3 succs { 4 5 }
;; 4 succs { 6 }
;; 5 succs { 6 }
;; 6 succs { 8 }
;; 7 succs { 17 8 }
;; 8 succs { 10 }
;; 18 succs { 9 }
;; 9 succs { 18 10 }
;; 10 succs { 11 }
;; 11 succs { 12 13 }
;; 12 succs { 16 }
;; 13 succs { 14 15 }
;; 14 succs { 16 }
;; 15 succs { 11 }
;; 16 succs { 1 }
;; 17 succs { 9 }

SSA replacement table
N_i -> { O_1 ... O_j } means that N_i replaces O_1, ..., O_j

D.8953_7 -> { D.8953_24 }
D.8953_93 -> { D.8953_24 }
pacb_94 -> { pacb_17 }

Number of virtual NEW -> OLD mappings:       0
Number of real NEW -> OLD mappings:          3
Number of total NEW -> OLD mappings:         3

Number of virtual symbols: 0


Incremental SSA update started at block: 19

Number of blocks in CFG: 21
Number of blocks to update: 8 ( 38%)



Merging blocks 10 and 19
Merging blocks 15 and 11
Removing basic block 18
Removing basic block 21
Removing basic block 22
paio_cancel (struct BlockDriverAIOCB * blockacb)
{
  struct qemu_paiocb * D.9548;
  struct qemu_paiocb * D.9547;
  struct PosixAioState * posix_aio_state.68;
  struct qemu_paiocb * D.8953;
  struct _IO_FILE * stderr.69;
  struct FILE * restrict stderr.70;
  const char * restrict D.8950;
  struct qemu_paiocb * D.8949;
  struct qemu_paiocb * * pacb;
  struct qemu_paiocb * acb;
  int D.7141;
  ssize_t D.7136;
  struct qemu_paiocb * * D.7133;
  struct qemu_paiocb * D.7130;
  int D.7127;

<bb 2>:
  acb_3 = (struct qemu_paiocb *) blockacb_2(D);
  mutex_lock.clone.1 ();
  D.7127_5 = acb_3->active;
  if (D.7127_5 == 0)
    goto <bb 3>;
  else
    goto <bb 7>;

<bb 3>:
  D.7130_6 = acb_3->node.tqe_next;
  if (D.7130_6 != 0B)
    goto <bb 4>;
  else
    goto <bb 5>;

<bb 4>:
  D.7133_8 = acb_3->node.tqe_prev;
  D.7130_6->node.tqe_prev = D.7133_8;
  goto <bb 6>;

<bb 5>:
  D.7133_9 = acb_3->node.tqe_prev;
  request_list.tqh_last = D.7133_9;

<bb 6>:
  D.7133_10 = acb_3->node.tqe_prev;
  D.7130_11 = acb_3->node.tqe_next;
  *D.7133_10 = D.7130_11;
  acb_3->ret = -125;
  goto <bb 8>;

<bb 7>:
  D.7136_12 = acb_3->ret;
  if (D.7136_12 == -115)
    goto <bb 17>;
  else
    goto <bb 8>;

<bb 8>:
Invalid sum of outgoing probabilities 0.0%
Invalid sum of incoming frequencies 757, should be 440
  mutex_unlock.clone.0 ();
  goto <bb 10>;

<bb 9>:
Invalid sum of incoming frequencies 2825, should be 3142
  D.7141_14 = qemu_paio_error (acb_3);
  if (D.7141_14 == 115)
    goto <bb 9>;
  else
    goto <bb 10>;

<bb 10>:
Invalid sum of incoming frequencies 440, should be 880
  posix_aio_state.68_15 = posix_aio_state;
  pacb_16 = &posix_aio_state.68_15->first_aio;
  D.9547_91 = posix_aio_state.68_15->first_aio;
  if (D.9547_91 == 0B)
    goto <bb 12>;
  else
    goto <bb 11>;

<bb 11>:
  if (acb_3 == D.9547_91)
    goto <bb 14>;
  else
    goto <bb 15>;

<bb 12>:
  stderr.69_19 = stderr;
  stderr.70_20 = (struct FILE * restrict) stderr.69_19;
  D.8950_21 = (const char * restrict) "paio_remove: aio request not found!\n";
  __builtin_fwrite (D.8950_21, 1, 36, stderr.70_20);
  goto <bb 16>;

<bb 13>:
  if (acb_3 == D.9548_92)
    goto <bb 14>;
  else
    goto <bb 15>;

<bb 14>:
  # pacb_95 = PHI <pacb_25(13), pacb_16(11)>
  D.8949_23 = acb_3->next;
  *pacb_95 = D.8949_23;
  qemu_aio_release (acb_3);
  goto <bb 16>;

<bb 15>:
  # D.8953_7 = PHI <D.9548_92(13), D.9547_91(11)>
  pacb_25 = &D.8953_7->next;
  D.9548_92 = D.8953_7->next;
  if (D.9548_92 == 0B)
    goto <bb 12>;
  else
    goto <bb 13>;

<bb 16>:
  return;

<bb 17>:
  mutex_unlock.clone.0 ();
  goto <bb 9>;

}


