
;; Function posix_aio_flush (posix_aio_flush)

posix_aio_flush (void * opaque)
{
  struct PosixAioState * s;
  struct qemu_paiocb * D.7098;
  int D.7097;

<bb 2>:
  s_2 = (struct PosixAioState *) opaque_1(D);
  D.7098_3 = s_2->first_aio;
  D.7097_4 = D.7098_3 != 0B;
  return D.7097_4;

}



;; Function die2 (die2)

die2 (int err, const char * what)
{
  struct FILE * restrict stderr.23;
  struct _IO_FILE * stderr.22;
  const char * restrict D.6724;
  char * D.6723;

<bb 2>:
  D.6723_2 = strerror (err_1(D));
  D.6724_3 = (const char * restrict) "%s failed: %s\n";
  stderr.22_4 = stderr;
  stderr.23_5 = (struct FILE * restrict) stderr.22_4;
  fprintf (stderr.23_5, D.6724_3, what_6(D), D.6723_2);
  abort ();

}



;; Function paio_init (paio_init)

paio_init ()
{
  int ret;
  int fds[2];
  struct PosixAioState * s;
  struct sigaction act;
  int D.7210;
  int D.7209;
  int D.7208;
  int D.7207;
  const char * restrict D.7206;
  struct FILE * restrict stderr.77;
  struct _IO_FILE * stderr.76;
  int D.7201;
  const struct sigaction * restrict act.75;
  void * D.7199;
  void * D.7198;
  struct PosixAioState * posix_aio_state.74;

<bb 2>:
  posix_aio_state.74_2 = posix_aio_state;
  if (posix_aio_state.74_2 != 0B)
    goto <bb 10>;
  else
    goto <bb 3>;

<bb 3>:
  D.7199_4 = qemu_malloc (12);
  s_5 = (struct PosixAioState *) D.7199_4;
  sigfillset (&act.sa_mask);
  act.sa_flags = 0;
  act.__sigaction_handler.sa_handler = aio_signal_handler;
  act.75_6 = (const struct sigaction * restrict) &act;
  sigaction (12, act.75_6, 0B);
  s_5->first_aio = 0B;
  D.7201_7 = pipe (&fds);
  if (D.7201_7 == -1)
    goto <bb 4>;
  else
    goto <bb 5>;

<bb 4>:
  stderr.76_8 = stderr;
  stderr.77_9 = (struct FILE * restrict) stderr.76_8;
  D.7206_10 = (const char * restrict) "failed to create pipe\n";
  __builtin_fwrite (D.7206_10, 1, 22, stderr.77_9);
  goto <bb 10>;

<bb 5>:
  D.7207_12 = fds[0];
  s_5->rfd = D.7207_12;
  D.7208_13 = fds[1];
  s_5->wfd = D.7208_13;
  fcntl (D.7207_12, 4, 2048);
  D.7210_15 = s_5->wfd;
  fcntl (D.7210_15, 4, 2048);
  D.7209_16 = s_5->rfd;
  qemu_aio_set_fd_handler (D.7209_16, posix_aio_read, 0B, posix_aio_flush, s_5);
  ret_17 = pthread_attr_init (&attr);
  if (ret_17 != 0)
    goto <bb 6>;
  else
    goto <bb 7>;

<bb 6>:
  die2 (ret_17, &"pthread_attr_init"[0]);

<bb 7>:
  ret_19 = pthread_attr_setdetachstate (&attr, 1);
  if (ret_19 != 0)
    goto <bb 8>;
  else
    goto <bb 9>;

<bb 8>:
  die2 (ret_19, &"pthread_attr_setdetachstate"[0]);

<bb 9>:
  request_list.tqh_first = 0B;
  request_list.tqh_last = &request_list.tqh_first;
  posix_aio_state = s_5;

<bb 10>:
  # D.7198_1 = PHI <posix_aio_state.74_2(2), 0B(4), s_5(9)>
  return D.7198_1;

}



;; Function die (die)

die (const char * what)
{
  int D.6731;
  int * D.6730;

<bb 2>:
  D.6730_1 = __errno_location ();
  D.6731_2 = *D.6730_1;
  die2 (D.6731_2, what_3(D));
  return;

}



;; Function aio_signal_handler (aio_signal_handler)

aio_signal_handler (int signum)
{
  char byte;
  int D.7107;
  struct PosixAioState * posix_aio_state.68;

<bb 2>:
  posix_aio_state.68_1 = posix_aio_state;
  if (posix_aio_state.68_1 != 0B)
    goto <bb 3>;
  else
    goto <bb 4>;

<bb 3>:
  byte = 0;
  D.7107_3 = posix_aio_state.68_1->wfd;
  write (D.7107_3, &byte, 1);

<bb 4>:
  qemu_service_io ();
  return;

}



;; Function handle_aiocb_rw_linear (handle_aiocb_rw_linear)

handle_aiocb_rw_linear (struct qemu_paiocb * aiocb, char * buf)
{
  size_t len;
  size_t offset;
  int D.6881;
  int D.6877;
  int * D.6876;
  ssize_t D.6873;
  void * D.6872;
  ssize_t D.6870;
  int D.6869;
  const void * D.6868;
  size_t D.6867;
  size_t D.6866;
  off_t D.6865;
  off_t D.6864;
  off_t D.6863;
  int D.6860;
  int D.6859;

<bb 2>:
  goto <bb 12>;

<bb 3>:
  D.6859_7 = aiocb_5(D)->aio_type;
  D.6860_8 = D.6859_7 & 2;
  if (D.6860_8 != 0)
    goto <bb 4>;
  else
    goto <bb 5>;

<bb 4>:
  D.6863_9 = aiocb_5(D)->aio_offset;
  D.6864_10 = (off_t) offset_1;
  D.6865_11 = D.6863_9 + D.6864_10;
  D.6867_13 = D.6866_6 - offset_1;
  D.6868_15 = buf_14(D) + offset_1;
  D.6869_16 = aiocb_5(D)->aio_fildes;
  D.6870_17 = pwrite (D.6869_16, D.6868_15, D.6867_13, D.6865_11);
  len_18 = (size_t) D.6870_17;
  goto <bb 6>;

<bb 5>:
  D.6863_19 = aiocb_5(D)->aio_offset;
  D.6864_20 = (off_t) offset_1;
  D.6865_21 = D.6863_19 + D.6864_20;
  D.6867_23 = D.6866_6 - offset_1;
  D.6872_24 = buf_14(D) + offset_1;
  D.6869_25 = aiocb_5(D)->aio_fildes;
  D.6873_26 = pread (D.6869_25, D.6872_24, D.6867_23, D.6865_21);
  len_27 = (size_t) D.6873_26;

<bb 6>:
  # len_3 = PHI <len_18(4), len_27(5)>
  if (len_3 == 0x0ffffffff)
    goto <bb 7>;
  else
    goto <bb 9>;

<bb 7>:
  D.6876_28 = __errno_location ();
  D.6877_29 = *D.6876_28;
  if (D.6877_29 == 4)
    goto <bb 11>;
  else
    goto <bb 8>;

<bb 8>:
Invalid sum of incoming frequencies 1956, should be 268
  D.6876_30 = __errno_location ();
  D.6877_31 = *D.6876_30;
  D.6881_32 = -D.6877_31;
  offset_33 = (size_t) D.6881_32;
  goto <bb 13>;

<bb 9>:
Invalid sum of incoming frequencies 6984, should be 8671
  if (len_3 == 0)
    goto <bb 13>;
  else
    goto <bb 10>;

<bb 10>:
  offset_34 = offset_1 + len_3;

<bb 11>:
  # offset_35 = PHI <offset_1(7), offset_34(10)>

<bb 12>:
  # offset_1 = PHI <offset_35(11), 0(2)>
  D.6866_6 = aiocb_5(D)->aio_nbytes;
  if (D.6866_6 > offset_1)
    goto <bb 3>;
  else
    goto <bb 13>;

<bb 13>:
  # offset_2 = PHI <offset_33(8), offset_1(9), offset_1(12)>
  return offset_2;

}



;; Function mutex_unlock.clone.0 (mutex_unlock.clone.0)

mutex_unlock.clone.0 ()
{
  int ret;
  union pthread_mutex_t * mutex;

<bb 2>:
  ret_1 = pthread_mutex_unlock (&lock);
  if (ret_1 != 0)
    goto <bb 3>;
  else
    goto <bb 4>;

<bb 3>:
  die2 (ret_1, &"pthread_mutex_unlock"[0]);

<bb 4>:
  return;

}



;; Function mutex_lock.clone.1 (mutex_lock.clone.1)

mutex_lock.clone.1 ()
{
  int ret;
  union pthread_mutex_t * mutex;

<bb 2>:
  ret_1 = pthread_mutex_lock (&lock);
  if (ret_1 != 0)
    goto <bb 3>;
  else
    goto <bb 4>;

<bb 3>:
  die2 (ret_1, &"pthread_mutex_lock"[0]);

<bb 4>:
  return;

}



;; Function qemu_paio_submit (qemu_paio_submit)

qemu_paio_submit (struct qemu_paiocb * aiocb)
{
  int cur_threads.53;
  int cur_threads.54;
  int idle_threads.55;
  int idle_threads.56;
  int D.9247;
  struct __sigset_t * restrict oldset.57;
  const struct __sigset_t * restrict set.58;
  int D.9244;
  const struct __sigset_t * restrict oldset.59;
  int D.9242;
  struct sigset_t set;
  struct sigset_t oldset;
  int ret;
  const union pthread_attr_t * restrict attr.29;
  int ret;
  struct qemu_paiocb * * D.7033;
  struct qemu_paiocb * * D.7032;
  int cur_threads.61;
  int idle_threads.60;

<bb 2>:
  aiocb_1(D)->ret = -115;
  aiocb_1(D)->active = 0;
  mutex_lock.clone.1 ();
  idle_threads.60_2 = idle_threads;
  if (idle_threads.60_2 == 0)
    goto <bb 3>;
  else
    goto <bb 12>;

<bb 3>:
  cur_threads.61_3 = cur_threads;
  if (cur_threads.61_3 <= 63)
    goto <bb 4>;
  else
    goto <bb 12>;

<bb 4>:
  cur_threads.54_10 = cur_threads.61_3 + 1;
  cur_threads = cur_threads.54_10;
  idle_threads = 1;
  D.9247_13 = sigfillset (&set);
  if (D.9247_13 != 0)
    goto <bb 5>;
  else
    goto <bb 6>;

<bb 5>:
  die (&"sigfillset"[0]);

<bb 6>:
  oldset.57_14 = (struct __sigset_t * restrict) &oldset;
  set.58_15 = (const struct __sigset_t * restrict) &set;
  D.9244_16 = pthread_sigmask (2, set.58_15, oldset.57_14);
  if (D.9244_16 != 0)
    goto <bb 7>;
  else
    goto <bb 8>;

<bb 7>:
  die (&"pthread_sigmask"[0]);

<bb 8>:
  attr.29_17 = (const union pthread_attr_t * restrict) &attr;
  ret_18 = pthread_create (&thread_id, attr.29_17, aio_thread, 0B);
  if (ret_18 != 0)
    goto <bb 9>;
  else
    goto <bb 10>;

<bb 9>:
  die2 (ret_18, &"pthread_create"[0]);

<bb 10>:
  D.9242_20 = pthread_sigmask (2, oldset.57_14, 0B);
  if (D.9242_20 != 0)
    goto <bb 11>;
  else
    goto <bb 12>;

<bb 11>:
  die (&"pthread_sigmask restore"[0]);

<bb 12>:
  aiocb_1(D)->node.tqe_next = 0B;
  D.7032_5 = request_list.tqh_last;
  aiocb_1(D)->node.tqe_prev = D.7032_5;
  D.7032_6 = request_list.tqh_last;
  *D.7032_6 = aiocb_1(D);
  D.7033_7 = &aiocb_1(D)->node.tqe_next;
  request_list.tqh_last = D.7033_7;
  mutex_unlock.clone.0 ();
  ret_8 = pthread_cond_signal (&cond);
  if (ret_8 != 0)
    goto <bb 13>;
  else
    goto <bb 14>;

<bb 13>:
  die2 (ret_8, &"pthread_cond_signal"[0]);

<bb 14>:
  return;

}



;; Function paio_ioctl (paio_ioctl)

paio_ioctl (struct BlockDriverState * bs, int fd, long unsigned int req, void * buf, void (*<T122d>) (void *, int) cb, void * opaque)
{
  struct qemu_paiocb * acb;
  struct qemu_paiocb * D.7187;
  struct PosixAioState * posix_aio_state.73;
  struct BlockDriverAIOCB * D.7185;
  void * D.7182;

<bb 2>:
  D.7182_5 = qemu_aio_get (&raw_aio_pool, bs_2(D), cb_3(D), opaque_4(D));
  acb_6 = (struct qemu_paiocb *) D.7182_5;
  if (acb_6 == 0B)
    goto <bb 4>;
  else
    goto <bb 3>;

<bb 3>:
  acb_6->aio_type = 4;
  acb_6->aio_fildes = fd_8(D);
  acb_6->ev_signo = 12;
  acb_6->aio_offset = 0;
  acb_6->D.6689.aio_ioctl_buf = buf_9(D);
  acb_6->aio_nbytes = req_10(D);
  posix_aio_state.73_11 = posix_aio_state;
  D.7187_12 = posix_aio_state.73_11->first_aio;
  acb_6->next = D.7187_12;
  posix_aio_state.73_11->first_aio = acb_6;
  qemu_paio_submit (acb_6);
  D.7185_14 = &acb_6->common;

<bb 4>:
  # D.7185_1 = PHI <0B(2), D.7185_14(3)>
  return D.7185_1;

}



;; Function paio_submit (paio_submit)

paio_submit (struct BlockDriverState * bs, void * aio_ctx, int fd, int64_t sector_num, struct QEMUIOVector * qiov, int nb_sectors, void (*<T122d>) (void *, int) cb, void * opaque, int type)
{
  struct qemu_paiocb * acb;
  struct qemu_paiocb * D.7172;
  struct PosixAioState * posix_aio_state.72;
  int64_t D.7170;
  size_t D.7169;
  int D.7168;
  int D.7167;
  struct iovec * D.7166;
  struct BlockDriverAIOCB * D.7163;
  void * D.7160;

<bb 2>:
  D.7160_5 = qemu_aio_get (&raw_aio_pool, bs_2(D), cb_3(D), opaque_4(D));
  acb_6 = (struct qemu_paiocb *) D.7160_5;
  if (acb_6 == 0B)
    goto <bb 6>;
  else
    goto <bb 3>;

<bb 3>:
  acb_6->aio_type = type_8(D);
  acb_6->aio_fildes = fd_9(D);
  acb_6->ev_signo = 12;
  if (qiov_10(D) != 0B)
    goto <bb 4>;
  else
    goto <bb 5>;

<bb 4>:
  D.7166_11 = qiov_10(D)->iov;
  acb_6->D.6689.aio_iov = D.7166_11;
  D.7167_12 = qiov_10(D)->niov;
  acb_6->aio_niov = D.7167_12;

<bb 5>:
  D.7168_14 = nb_sectors_13(D) * 512;
  D.7169_15 = (size_t) D.7168_14;
  acb_6->aio_nbytes = D.7169_15;
  D.7170_17 = sector_num_16(D) * 512;
  acb_6->aio_offset = D.7170_17;
  posix_aio_state.72_18 = posix_aio_state;
  D.7172_19 = posix_aio_state.72_18->first_aio;
  acb_6->next = D.7172_19;
  posix_aio_state.72_18->first_aio = acb_6;
  qemu_paio_submit (acb_6);
  D.7163_21 = &acb_6->common;

<bb 6>:
  # D.7163_1 = PHI <0B(2), D.7163_21(5)>
  return D.7163_1;

}



;; Function aio_thread (aio_thread)

aio_thread (void * unused)
{
  int D.9376;
  int D.9375;
  int D.9374;
  struct iovec * D.9373;
  void * D.9372;
  char * D.9371;
  int preadv_present.35;
  size_t D.9369;
  void * D.9368;
  int D.9367;
  unsigned int i.37;
  unsigned int D.9365;
  struct iovec * D.9364;
  size_t D.9363;
  void * D.9362;
  unsigned int i.39;
  unsigned int D.9360;
  struct iovec * D.9359;
  size_t D.9358;
  void * D.9357;
  _Bool D.9356;
  _Bool D.9355;
  _Bool D.9354;
  int i;
  char * p;
  size_t copy;
  int i;
  __off_t D.9353;
  __off_t D.9352;
  ssize_t len;
  int D.9351;
  int D.9350;
  int * D.9349;
  int D.9348;
  struct iovec * D.9347;
  int D.9346;
  off_t D.9345;
  int D.9344;
  int D.9343;
  void * D.9025;
  size_t D.9024;
  int D.9023;
  int * D.9021;
  int D.9020;
  int D.9019;
  int ret;
  int D.9015;
  int * D.9013;
  int D.9012;
  int D.9011;
  int ret;
  const struct timespec * restrict ts.26;
  _Bool D.9006;
  _Bool D.9005;
  _Bool D.9004;
  int ret;
  struct timespec ts;
  struct qemu_timeval tv;
  size_t ret;
  struct qemu_paiocb * aiocb;
  struct sigset_t set;
  pid_t pid;
  int cur_threads.52;
  int cur_threads.51;
  int D.6995;
  int D.6994;
  int idle_threads.50;
  ssize_t ret.49;
  struct FILE * restrict stderr.48;
  struct _IO_FILE * stderr.47;
  const char * restrict D.6989;
  int D.6985;
  int D.6984;
  int idle_threads.43;
  int idle_threads.42;
  struct qemu_paiocb * * D.6980;
  struct qemu_paiocb * D.6977;
  _Bool D.6975;
  _Bool D.6974;
  _Bool D.6973;
  struct qemu_paiocb * D.6972;
  long int D.6970;
  __time_t D.6969;
  struct timeval * restrict tv.41;
  int D.6964;

<bb 2>:
  D.6964_3 = sigfillset (&set);
  if (D.6964_3 != 0)
    goto <bb 3>;
  else
    goto <bb 4>;

<bb 3>:
  die (&"sigfillset"[0]);

<bb 4>:
  pid_4 = getpid ();

<bb 5>:

<bb 6>:
  tv.41_7 = (struct timeval * restrict) &tv;
  gettimeofday (tv.41_7, 0B);
  D.6969_8 = tv.tv_sec;
  D.6970_9 = D.6969_8 + 10;
  ts.tv_sec = D.6970_9;
  ts.tv_nsec = 0;
  mutex_lock.clone.1 ();
  D.6972_422 = request_list.tqh_first;
  D.6973_423 = D.6972_422 == 0B;
  D.6974_424 = 1;
  D.6975_425 = D.6973_423 & D.6974_424;
  if (D.6975_425 != 0)
    goto <bb 7>;
  else
    goto <bb 10>;

<bb 7>:
  ts.26_49 = (const struct timespec * restrict) &ts;
  ret_50 = pthread_cond_timedwait (&cond, &lock, ts.26_49);
  D.9006_51 = ret_50 != 0;
  D.9005_52 = ret_50 != 110;
  D.9004_53 = D.9006_51 & D.9005_52;
  if (D.9004_53 != 0)
    goto <bb 8>;
  else
    goto <bb 9>;

<bb 8>:
  die2 (ret_50, &"pthread_cond_timedwait"[0]);

<bb 9>:
  ret_15 = (size_t) ret_50;
  D.6972_10 = request_list.tqh_first;
  D.6973_11 = D.6972_10 == 0B;
  D.6974_12 = ret_15 != 110;
  D.6975_13 = D.6973_11 & D.6974_12;
  if (D.6975_13 != 0)
    goto <bb 7>;
  else
    goto <bb 10>;

<bb 10>:
  # D.6972_144 = PHI <D.6972_10(9), D.6972_422(6)>
  if (D.6972_144 == 0B)
    goto <bb 44>;
  else
    goto <bb 11>;

<bb 11>:
  aiocb_17 = D.6972_144;
  D.6977_18 = D.6972_144->node.tqe_next;
  if (D.6977_18 != 0B)
    goto <bb 12>;
  else
    goto <bb 13>;

<bb 12>:
  D.6980_20 = aiocb_17->node.tqe_prev;
  D.6977_18->node.tqe_prev = D.6980_20;
  goto <bb 14>;

<bb 13>:
  D.6980_21 = aiocb_17->node.tqe_prev;
  request_list.tqh_last = D.6980_21;

<bb 14>:
  D.6980_22 = aiocb_17->node.tqe_prev;
  D.6977_23 = aiocb_17->node.tqe_next;
  *D.6980_22 = D.6977_23;
  aiocb_17->active = 1;
  idle_threads.42_24 = idle_threads;
  idle_threads.43_25 = idle_threads.42_24 + -1;
  idle_threads = idle_threads.43_25;
  mutex_unlock.clone.0 ();
  D.6984_26 = aiocb_17->aio_type;
  D.6985_27 = D.6984_26 & 15;
  switch (D.6985_27) <default: <L14>, case 1 ... 2: <L22>, case 4: <L21>, case 8: <L20>>

<L22>:
  D.9375_75 = D.6984_26 & 4096;
  if (D.9375_75 == 0)
    goto <bb 16>;
  else
    goto <bb 28>;

<bb 16>:
  D.9374_76 = aiocb_17->aio_niov;
  if (D.9374_76 == 1)
    goto <bb 17>;
  else
    goto <bb 18>;

<bb 17>:
  D.9373_77 = aiocb_17->D.6689.aio_iov;
  D.9372_78 = D.9373_77->iov_base;
  D.9371_79 = (char *) D.9372_78;
  ret_80 = handle_aiocb_rw_linear (aiocb_17, D.9371_79);
  goto <bb 35>;

<bb 18>:
  preadv_present.35_81 = preadv_present;
  if (preadv_present.35_81 != 0)
    goto <bb 19>;
  else
    goto <bb 28>;

<bb 19>:

<bb 20>:
  D.9343_82 = aiocb_17->aio_type;
  D.9344_83 = D.9343_82 & 2;
  if (D.9344_83 != 0)
    goto <bb 21>;
  else
    goto <bb 22>;

<bb 21>:
  D.9345_84 = aiocb_17->aio_offset;
  D.9346_85 = aiocb_17->aio_niov;
  D.9347_86 = aiocb_17->D.6689.aio_iov;
  D.9348_87 = aiocb_17->aio_fildes;
  D.9352_88 = (__off_t) D.9345_84;
  len_89 = pwritev (D.9348_87, D.9347_86, D.9346_85, D.9352_88);
  goto <bb 23>;

<bb 22>:
  D.9345_90 = aiocb_17->aio_offset;
  D.9346_91 = aiocb_17->aio_niov;
  D.9347_92 = aiocb_17->D.6689.aio_iov;
  D.9348_93 = aiocb_17->aio_fildes;
  D.9353_94 = (__off_t) D.9345_90;
  len_95 = preadv (D.9348_93, D.9347_92, D.9346_91, D.9353_94);

<bb 23>:
  # len_96 = PHI <len_89(21), len_95(22)>
  if (len_96 == -1)
    goto <bb 24>;
  else
    goto <bb 25>;

<bb 24>:
  D.9349_97 = __errno_location ();
  D.9350_98 = *D.9349_97;
  if (D.9350_98 == 4)
    goto <bb 20>;
  else
    goto <bb 45>;

<bb 25>:
  # len_145 = PHI <len_96(23)>
  ret_103 = (size_t) len_145;

<bb 26>:
  # ret_105 = PHI <ret_102(45), ret_103(25)>
  D.9369_104 = aiocb_17->aio_nbytes;
  if (D.9369_104 == ret_105)
    goto <bb 35>;
  else
    goto <bb 27>;

<bb 27>:
  preadv_present = 0;

<bb 28>:
  D.9369_106 = aiocb_17->aio_nbytes;
  D.9368_107 = qemu_memalign (512, D.9369_106);
  p_108 = (char *) D.9368_107;
  D.9376_109 = aiocb_17->aio_type;
  D.9367_110 = D.9376_109 & 2;
  if (D.9367_110 != 0)
    goto <bb 29>;
  else
    goto <bb 31>;

<bb 29>:
  # p_164 = PHI <p_108(28)>
  D.9374_117 = aiocb_17->aio_niov;
  if (D.9374_117 > 0)
    goto <bb 30>;
  else
    goto <bb 31>;

<bb 30>:
  # i_399 = PHI <i_129(30), 0(29)>
  # p_398 = PHI <p_128(30), p_164(29)>
  D.9373_111 = aiocb_17->D.6689.aio_iov;
  i.37_113 = (unsigned int) i_399;
  D.9365_114 = i.37_113 * 8;
  D.9364_115 = D.9373_111 + D.9365_114;
  D.9363_116 = D.9364_115->iov_len;
  D.9362_121 = D.9364_115->iov_base;
  memcpy (p_398, D.9362_121, D.9363_116);
  D.9373_123 = aiocb_17->D.6689.aio_iov;
  D.9364_126 = D.9373_123 + D.9365_114;
  D.9363_127 = D.9364_126->iov_len;
  p_128 = p_398 + D.9363_127;
  i_129 = i_399 + 1;
  D.9374_130 = aiocb_17->aio_niov;
  if (i_129 < D.9374_130)
    goto <bb 30>;
  else
    goto <bb 31>;

<bb 31>:
  ret_131 = handle_aiocb_rw_linear (aiocb_17, p_108);
  D.9376_132 = aiocb_17->aio_type;
  D.9367_133 = D.9376_132 & 2;
  if (D.9367_133 == 0)
    goto <bb 32>;
  else
    goto <bb 34>;

<bb 32>:
  copy_134 = aiocb_17->aio_nbytes;
  D.9374_412 = aiocb_17->aio_niov;
  D.9356_406 = D.9374_412 > 0;
  D.9355_120 = copy_134 != 0;
  D.9354_405 = D.9356_406 & D.9355_120;
  if (D.9354_405 != 0)
    goto <bb 33>;
  else
    goto <bb 34>;

<bb 33>:
  # i_404 = PHI <i_156(33), 0(32)>
  # copy_119 = PHI <copy_155(33), copy_134(32)>
  # p_403 = PHI <p_154(33), p_108(32)>
  D.9373_135 = aiocb_17->D.6689.aio_iov;
  i.39_137 = (unsigned int) i_404;
  D.9360_138 = i.39_137 * 8;
  D.9359_139 = D.9373_135 + D.9360_138;
  D.9358_140 = D.9359_139->iov_len;
  copy_19 = MIN_EXPR <copy_119, D.9358_140>;
  D.9357_151 = D.9359_139->iov_base;
  memcpy (D.9357_151, p_403, copy_19);
  p_154 = p_403 + copy_19;
  copy_155 = copy_119 - copy_19;
  i_156 = i_404 + 1;
  D.9374_157 = aiocb_17->aio_niov;
  D.9356_158 = i_156 < D.9374_157;
  D.9355_159 = copy_155 != 0;
  D.9354_160 = D.9356_158 & D.9355_159;
  if (D.9354_160 != 0)
    goto <bb 33>;
  else
    goto <bb 34>;

<bb 34>:
  qemu_vfree (p_108);

<bb 35>:
  # ret_161 = PHI <ret_80(17), D.9369_104(26), ret_131(34)>
  goto <bb 42>;

<L20>:
  D.9015_54 = aiocb_17->aio_fildes;
  ret_55 = qemu_fdatasync (D.9015_54);
  if (ret_55 == -1)
    goto <bb 37>;
  else
    goto <bb 42>;

<bb 37>:
  D.9013_56 = __errno_location ();
  D.9012_57 = *D.9013_56;
  D.9011_58 = -D.9012_57;
  ret_59 = (size_t) D.9011_58;
  goto <bb 42>;

<L21>:
  D.9025_61 = aiocb_17->D.6689.aio_ioctl_buf;
  D.9024_62 = aiocb_17->aio_nbytes;
  D.9023_63 = aiocb_17->aio_fildes;
  ret_64 = ioctl (D.9023_63, D.9024_62, D.9025_61);
  if (ret_64 == -1)
    goto <bb 39>;
  else
    goto <bb 40>;

<bb 39>:
  D.9021_65 = __errno_location ();
  D.9020_66 = *D.9021_65;
  D.9019_67 = -D.9020_66;
  ret_68 = (size_t) D.9019_67;
  goto <bb 42>;

<bb 40>:
  ret_69 = aiocb_17->aio_nbytes;
  goto <bb 42>;

<L14>:
  D.6989_35 = (const char * restrict) "invalid aio request (0x%x)\n";
  stderr.47_36 = stderr;
  stderr.48_37 = (struct FILE * restrict) stderr.47_36;
  fprintf (stderr.48_37, D.6989_35, D.6984_26);

<bb 42>:
  # ret_2 = PHI <ret_161(35), ret_59(37), ret_69(40), 0x0ffffffea(41), ret_68(39), 0(36)>
  mutex_lock.clone.1 ();
  ret.49_39 = (ssize_t) ret_2;
  aiocb_17->ret = ret.49_39;
  idle_threads.42_40 = idle_threads;
  idle_threads.50_41 = idle_threads.42_40 + 1;
  idle_threads = idle_threads.50_41;
  mutex_unlock.clone.0 ();
  D.6994_42 = aiocb_17->ev_signo;
  D.6995_43 = kill (pid_4, D.6994_42);
  if (D.6995_43 != 0)
    goto <bb 43>;
  else
    goto <bb 6>;

<bb 43>:
  die (&"kill failed"[0]);
  goto <bb 5>;

<bb 44>:
  idle_threads.42_44 = idle_threads;
  idle_threads.43_45 = idle_threads.42_44 + -1;
  idle_threads = idle_threads.43_45;
  cur_threads.51_46 = cur_threads;
  cur_threads.52_47 = cur_threads.51_46 + -1;
  cur_threads = cur_threads.52_47;
  mutex_unlock.clone.0 ();
  return 0B;

<bb 45>:
  D.9349_99 = __errno_location ();
  D.9350_100 = *D.9349_99;
  D.9351_101 = -D.9350_100;
  ret_102 = (size_t) D.9351_101;
  goto <bb 26>;

}



;; Function qemu_paio_error (qemu_paio_error)

qemu_paio_error (struct qemu_paiocb * aiocb)
{
  ssize_t ret;

<bb 2>:
  mutex_lock.clone.1 ();
  ret_8 = aiocb_2(D)->ret;
  mutex_unlock.clone.0 ();
  if (ret_8 < 0)
    goto <bb 3>;
  else
    goto <bb 4>;

<bb 3>:
  ret_5 = -ret_8;

<bb 4>:
  # ret_1 = PHI <ret_5(3), 0(2)>
  return ret_1;

}



;; Function posix_aio_read (posix_aio_read)

posix_aio_read (void * opaque)
{
  char bytes[16];
  ssize_t len;
  int ret;
  struct qemu_paiocb * * pacb;
  struct qemu_paiocb * acb;
  struct PosixAioState * s;
  void * D.7092;
  void (*<T122d>) (void *, int) D.7091;
  size_t D.7086;
  size_t ret.67;
  struct qemu_paiocb * D.7078;
  int D.7069;
  int * D.7068;
  int D.7064;

<bb 2>:
  s_4 = (struct PosixAioState *) opaque_3(D);
  goto <bb 4>;

<bb 3>:

<bb 4>:
  D.7064_5 = s_4->rfd;
  len_6 = read (D.7064_5, &bytes, 16);
  if (len_6 == -1)
    goto <bb 5>;
  else
    goto <bb 6>;

<bb 5>:
  D.7068_8 = __errno_location ();
  D.7069_9 = *D.7068_8;
  if (D.7069_9 == 4)
    goto <bb 3>;
  else
    goto <bb 7>;

<bb 6>:
  if (len_6 == 16)
    goto <bb 3>;
  else
    goto <bb 7>;

<bb 7>:

<bb 8>:
  pacb_10 = &s_4->first_aio;
  goto <bb 10>;

<bb 9>:
  # pacb_38 = PHI <pacb_25(19), pacb_1(12)>

<bb 10>:
  # pacb_1 = PHI <pacb_38(9), pacb_10(8)>
  acb_11 = *pacb_1;
  if (acb_11 == 0B)
    goto <bb 20> (the_end);
  else
    goto <bb 11>;

<bb 11>:
  ret_12 = qemu_paio_error (acb_11);
  if (ret_12 == 125)
    goto <bb 12>;
  else
    goto <bb 13>;

<bb 12>:
  D.7078_14 = acb_11->next;
  *pacb_1 = D.7078_14;
  qemu_aio_release (acb_11);
  goto <bb 9>;

<bb 13>:
  if (ret_12 != 115)
    goto <bb 14>;
  else
    goto <bb 19>;

<bb 14>:
  # pacb_79 = PHI <pacb_1(13)>
  # acb_80 = PHI <acb_11(13)>
  # ret_81 = PHI <ret_12(13)>
  if (ret_81 == 0)
    goto <bb 15>;
  else
    goto <bb 17>;

<bb 15>:
  mutex_lock.clone.1 ();
  ret_26 = acb_80->ret;
  mutex_unlock.clone.0 ();
  ret.67_17 = (size_t) ret_26;
  D.7086_18 = acb_80->aio_nbytes;
  if (ret.67_17 == D.7086_18)
    goto <bb 18>;
  else
    goto <bb 16>;

<bb 16>:
  goto <bb 18>;

<bb 17>:
  ret_21 = -ret_81;

<bb 18>:
  # ret_2 = PHI <-22(16), ret_21(17), 0(15)>
  D.7078_22 = acb_80->next;
  *pacb_79 = D.7078_22;
  D.7091_23 = acb_80->common.cb;
  D.7092_24 = acb_80->common.opaque;
  D.7091_23 (D.7092_24, ret_2);
  qemu_aio_release (acb_80);
  goto <bb 8>;

<bb 19>:
  pacb_25 = &acb_11->next;
  goto <bb 9>;

the_end:
  return;

}



;; Function paio_cancel (paio_cancel)

paio_cancel (struct BlockDriverAIOCB * blockacb)
{
  struct qemu_paiocb * D.9552;
  struct qemu_paiocb * D.9551;
  struct PosixAioState * posix_aio_state.69;
  struct qemu_paiocb * D.8958;
  struct _IO_FILE * stderr.70;
  struct FILE * restrict stderr.71;
  const char * restrict D.8955;
  struct qemu_paiocb * D.8954;
  struct qemu_paiocb * * pacb;
  struct qemu_paiocb * acb;
  int D.7146;
  ssize_t D.7141;
  struct qemu_paiocb * * D.7138;
  struct qemu_paiocb * D.7135;
  int D.7132;

<bb 2>:
  acb_3 = (struct qemu_paiocb *) blockacb_2(D);
  mutex_lock.clone.1 ();
  D.7132_5 = acb_3->active;
  if (D.7132_5 == 0)
    goto <bb 3>;
  else
    goto <bb 7>;

<bb 3>:
  D.7135_6 = acb_3->node.tqe_next;
  if (D.7135_6 != 0B)
    goto <bb 4>;
  else
    goto <bb 5>;

<bb 4>:
  D.7138_8 = acb_3->node.tqe_prev;
  D.7135_6->node.tqe_prev = D.7138_8;
  goto <bb 6>;

<bb 5>:
  D.7138_9 = acb_3->node.tqe_prev;
  request_list.tqh_last = D.7138_9;

<bb 6>:
  D.7138_10 = acb_3->node.tqe_prev;
  D.7135_11 = acb_3->node.tqe_next;
  *D.7138_10 = D.7135_11;
  acb_3->ret = -125;
  goto <bb 8>;

<bb 7>:
  D.7141_12 = acb_3->ret;
  if (D.7141_12 == -115)
    goto <bb 17>;
  else
    goto <bb 8>;

<bb 8>:
Invalid sum of outgoing probabilities 0.0%
Invalid sum of incoming frequencies 757, should be 440
  mutex_unlock.clone.0 ();
  goto <bb 10>;

<bb 9>:
Invalid sum of incoming frequencies 2825, should be 3142
  D.7146_14 = qemu_paio_error (acb_3);
  if (D.7146_14 == 115)
    goto <bb 9>;
  else
    goto <bb 10>;

<bb 10>:
Invalid sum of incoming frequencies 440, should be 880
  posix_aio_state.69_15 = posix_aio_state;
  pacb_16 = &posix_aio_state.69_15->first_aio;
  D.9551_91 = posix_aio_state.69_15->first_aio;
  if (D.9551_91 == 0B)
    goto <bb 12>;
  else
    goto <bb 11>;

<bb 11>:
  if (acb_3 == D.9551_91)
    goto <bb 14>;
  else
    goto <bb 15>;

<bb 12>:
  stderr.70_19 = stderr;
  stderr.71_20 = (struct FILE * restrict) stderr.70_19;
  D.8955_21 = (const char * restrict) "paio_remove: aio request not found!\n";
  __builtin_fwrite (D.8955_21, 1, 36, stderr.71_20);
  goto <bb 16>;

<bb 13>:
  if (acb_3 == D.9552_92)
    goto <bb 14>;
  else
    goto <bb 15>;

<bb 14>:
  # pacb_95 = PHI <pacb_25(13), pacb_16(11)>
  D.8954_23 = acb_3->next;
  *pacb_95 = D.8954_23;
  qemu_aio_release (acb_3);
  goto <bb 16>;

<bb 15>:
  # D.8958_7 = PHI <D.9552_92(13), D.9551_91(11)>
  pacb_25 = &D.8958_7->next;
  D.9552_92 = D.8958_7->next;
  if (D.9552_92 == 0B)
    goto <bb 12>;
  else
    goto <bb 13>;

<bb 16>:
  return;

<bb 17>:
  mutex_unlock.clone.0 ();
  goto <bb 9>;

}


