
;; Function paio_init (paio_init)

paio_init ()
{
  int ret;
  int fds[2];
  struct PosixAioState * s;
  struct sigaction act;
  int ret.78;
  int ret.77;
  int D.7205;
  int D.7204;
  int D.7203;
  int D.7202;
  const char * restrict D.7201;
  struct FILE * restrict stderr.76;
  struct _IO_FILE * stderr.75;
  int D.7196;
  const struct sigaction * restrict act.74;
  void * D.7194;
  void * D.7193;
  struct PosixAioState * posix_aio_state.73;

  posix_aio_state.73 = posix_aio_state;
  if (posix_aio_state.73 != 0B) goto <D.7191>; else goto <D.7192>;
  <D.7191>:
  D.7193 = posix_aio_state;
  goto <D.8926>;
  <D.7192>:
  D.7194 = qemu_malloc (12);
  s = (struct PosixAioState *) D.7194;
  sigfillset (&act.sa_mask);
  act.sa_flags = 0;
  act.__sigaction_handler.sa_handler = aio_signal_handler;
  act.74 = (const struct sigaction * restrict) &act;
  sigaction (12, act.74, 0B);
  s->first_aio = 0B;
  D.7196 = pipe (&fds);
  if (D.7196 == -1) goto <D.7197>; else goto <D.7198>;
  <D.7197>:
  stderr.75 = stderr;
  stderr.76 = (struct FILE * restrict) stderr.75;
  D.7201 = (const char * restrict) "failed to create pipe\n";
  __builtin_fwrite (D.7201, 1, 22, stderr.76);
  D.7193 = 0B;
  goto <D.8926>;
  <D.7198>:
  D.7202 = fds[0];
  s->rfd = D.7202;
  D.7203 = fds[1];
  s->wfd = D.7203;
  D.7204 = s->rfd;
  fcntl (D.7204, 4, 2048);
  D.7205 = s->wfd;
  fcntl (D.7205, 4, 2048);
  D.7204 = s->rfd;
  qemu_aio_set_fd_handler (D.7204, posix_aio_read, 0B, posix_aio_flush, s);
  ret.77 = pthread_attr_init (&attr);
  ret = ret.77;
  if (ret != 0) goto <D.7207>; else goto <D.7208>;
  <D.7207>:
  die2 (ret, &"pthread_attr_init"[0]);
  <D.7208>:
  ret.78 = pthread_attr_setdetachstate (&attr, 1);
  ret = ret.78;
  if (ret != 0) goto <D.7210>; else goto <D.7211>;
  <D.7210>:
  die2 (ret, &"pthread_attr_setdetachstate"[0]);
  <D.7211>:
  request_list.tqh_first = 0B;
  request_list.tqh_last = &request_list.tqh_first;
  posix_aio_state = s;
  D.7193 = posix_aio_state;
  goto <D.8926>;
  <D.8926>:
  return D.7193;
}



;; Function die2 (die2)

die2 (int err, const char * what)
{
  struct FILE * restrict stderr.23;
  struct _IO_FILE * stderr.22;
  const char * restrict D.6724;
  char * D.6723;

  D.6723 = strerror (err);
  D.6724 = (const char * restrict) "%s failed: %s\n";
  stderr.22 = stderr;
  stderr.23 = (struct FILE * restrict) stderr.22;
  fprintf (stderr.23, D.6724, what, D.6723);
  abort ();
}



;; Function posix_aio_flush (posix_aio_flush)

posix_aio_flush (void * opaque)
{
  struct PosixAioState * s;
  struct qemu_paiocb * D.7093;
  int D.7092;

  s = (struct PosixAioState *) opaque;
  D.7093 = s->first_aio;
  D.7092 = D.7093 != 0B;
  goto <D.8927>;
  <D.8927>:
  return D.7092;
}



;; Function posix_aio_read (posix_aio_read)

posix_aio_read (void * opaque)
{
  char bytes[16];
  ssize_t len;
  int ret;
  struct qemu_paiocb * * pacb;
  struct qemu_paiocb * acb;
  struct PosixAioState * s;
  void * D.7087;
  void (*<T122d>) (void *, int) D.7086;
  size_t D.7081;
  size_t ret.66;
  ssize_t ret.65;
  struct qemu_paiocb * D.7073;
  int ret.64;
  int D.7064;
  int * D.7063;
  ssize_t len.63;
  int D.7059;

  s = (struct PosixAioState *) opaque;
  <D.7054>:
  D.7059 = s->rfd;
  len.63 = read (D.7059, &bytes, 16);
  len = len.63;
  if (len == -1) goto <D.7061>; else goto <D.7062>;
  <D.7061>:
  D.7063 = __errno_location ();
  D.7064 = *D.7063;
  if (D.7064 == 4) goto <D.7065>; else goto <D.7066>;
  <D.7065>:
  // predicted unlikely by continue predictor.
  goto <D.7052>;
  <D.7066>:
  <D.7062>:
  if (len == 16) goto <D.7067>; else goto <D.7068>;
  <D.7067>:
  // predicted unlikely by continue predictor.
  goto <D.7052>;
  <D.7068>:
  goto <D.7053>;
  <D.7052>:
  goto <D.7054>;
  <D.7053>:
  <D.7058>:
  pacb = &s->first_aio;
  <D.7057>:
  acb = *pacb;
  if (acb == 0B) goto the_end; else goto <D.7069>;
  <D.7069>:
  ret.64 = qemu_paio_error (acb);
  ret = ret.64;
  if (ret == 125) goto <D.7071>; else goto <D.7072>;
  <D.7071>:
  D.7073 = acb->next;
  *pacb = D.7073;
  qemu_aio_release (acb);
  goto <D.7074>;
  <D.7072>:
  if (ret != 115) goto <D.7075>; else goto <D.7076>;
  <D.7075>:
  if (ret == 0) goto <D.7077>; else goto <D.7078>;
  <D.7077>:
  ret.65 = qemu_paio_return (acb);
  ret = ret.65;
  ret.66 = (size_t) ret;
  D.7081 = acb->aio_nbytes;
  if (ret.66 == D.7081) goto <D.7082>; else goto <D.7083>;
  <D.7082>:
  ret = 0;
  goto <D.7084>;
  <D.7083>:
  ret = -22;
  <D.7084>:
  goto <D.7085>;
  <D.7078>:
  ret = -ret;
  <D.7085>:
  D.7073 = acb->next;
  *pacb = D.7073;
  D.7086 = acb->common.cb;
  D.7087 = acb->common.opaque;
  D.7086 (D.7087, ret);
  qemu_aio_release (acb);
  goto <D.7056>;
  <D.7076>:
  pacb = &acb->next;
  <D.7074>:
  goto <D.7057>;
  <D.7056>:
  goto <D.7058>;
  the_end:
  return;
}



;; Function qemu_paio_error (qemu_paio_error)

qemu_paio_error (struct qemu_paiocb * aiocb)
{
  ssize_t ret;
  int D.7042;
  ssize_t ret.62;

  ret.62 = qemu_paio_return (aiocb);
  ret = ret.62;
  if (ret < 0) goto <D.7039>; else goto <D.7040>;
  <D.7039>:
  ret = -ret;
  goto <D.7041>;
  <D.7040>:
  ret = 0;
  <D.7041>:
  D.7042 = ret;
  goto <D.8928>;
  <D.8928>:
  return D.7042;
}



;; Function qemu_paio_return (qemu_paio_return)

qemu_paio_return (struct qemu_paiocb * aiocb)
{
  ssize_t ret;
  ssize_t D.7033;

  mutex_lock (&lock);
  ret = aiocb->ret;
  mutex_unlock (&lock);
  D.7033 = ret;
  goto <D.8929>;
  <D.8929>:
  return D.7033;
}



;; Function mutex_lock (mutex_lock)

mutex_lock (union pthread_mutex_t * mutex)
{
  int ret;
  int ret.24;

  ret.24 = pthread_mutex_lock (mutex);
  ret = ret.24;
  if (ret != 0) goto <D.6737>; else goto <D.6738>;
  <D.6737>:
  die2 (ret, &"pthread_mutex_lock"[0]);
  <D.6738>:
  return;
}



;; Function mutex_unlock (mutex_unlock)

mutex_unlock (union pthread_mutex_t * mutex)
{
  int ret;
  int ret.25;

  ret.25 = pthread_mutex_unlock (mutex);
  ret = ret.25;
  if (ret != 0) goto <D.6744>; else goto <D.6745>;
  <D.6744>:
  die2 (ret, &"pthread_mutex_unlock"[0]);
  <D.6745>:
  return;
}



;; Function aio_signal_handler (aio_signal_handler)

aio_signal_handler (int signum)
{
  char byte;
  int D.7102;
  struct PosixAioState * posix_aio_state.67;

  posix_aio_state.67 = posix_aio_state;
  if (posix_aio_state.67 != 0B) goto <D.7100>; else goto <D.7101>;
  <D.7100>:
  byte = 0;
  posix_aio_state.67 = posix_aio_state;
  D.7102 = posix_aio_state.67->wfd;
  write (D.7102, &byte, 1);
  <D.7101>:
  qemu_service_io ();
  return;
}



;; Function paio_ioctl (paio_ioctl)

paio_ioctl (struct BlockDriverState * bs, int fd, long unsigned int req, void * buf, void (*<T122d>) (void *, int) cb, void * opaque)
{
  struct qemu_paiocb * acb;
  struct qemu_paiocb * D.7182;
  struct PosixAioState * posix_aio_state.72;
  struct BlockDriverAIOCB * D.7180;
  void * D.7177;

  D.7177 = qemu_aio_get (&raw_aio_pool, bs, cb, opaque);
  acb = (struct qemu_paiocb *) D.7177;
  if (acb == 0B) goto <D.7178>; else goto <D.7179>;
  <D.7178>:
  D.7180 = 0B;
  goto <D.8930>;
  <D.7179>:
  acb->aio_type = 4;
  acb->aio_fildes = fd;
  acb->ev_signo = 12;
  acb->aio_offset = 0;
  acb->D.6689.aio_ioctl_buf = buf;
  acb->aio_nbytes = req;
  posix_aio_state.72 = posix_aio_state;
  D.7182 = posix_aio_state.72->first_aio;
  acb->next = D.7182;
  posix_aio_state.72 = posix_aio_state;
  posix_aio_state.72->first_aio = acb;
  qemu_paio_submit (acb);
  D.7180 = &acb->common;
  goto <D.8930>;
  <D.8930>:
  return D.7180;
}



;; Function paio_cancel (paio_cancel)

paio_cancel (struct BlockDriverAIOCB * blockacb)
{
  int active;
  struct qemu_paiocb * acb;
  int D.7141;
  ssize_t D.7136;
  struct qemu_paiocb * * D.7133;
  struct qemu_paiocb * D.7130;
  int D.7127;

  acb = (struct qemu_paiocb *) blockacb;
  active = 0;
  mutex_lock (&lock);
  D.7127 = acb->active;
  if (D.7127 == 0) goto <D.7128>; else goto <D.7129>;
  <D.7128>:
  D.7130 = acb->node.tqe_next;
  if (D.7130 != 0B) goto <D.7131>; else goto <D.7132>;
  <D.7131>:
  D.7130 = acb->node.tqe_next;
  D.7133 = acb->node.tqe_prev;
  D.7130->node.tqe_prev = D.7133;
  goto <D.7134>;
  <D.7132>:
  D.7133 = acb->node.tqe_prev;
  request_list.tqh_last = D.7133;
  <D.7134>:
  D.7133 = acb->node.tqe_prev;
  D.7130 = acb->node.tqe_next;
  *D.7133 = D.7130;
  acb->ret = -125;
  goto <D.7135>;
  <D.7129>:
  D.7136 = acb->ret;
  if (D.7136 == -115) goto <D.7137>; else goto <D.7138>;
  <D.7137>:
  active = 1;
  <D.7138>:
  <D.7135>:
  mutex_unlock (&lock);
  if (active != 0) goto <D.7139>; else goto <D.7140>;
  <D.7139>:
  <D.7124>:
  <D.7125>:
  D.7141 = qemu_paio_error (acb);
  if (D.7141 == 115) goto <D.7124>; else goto <D.7126>;
  <D.7126>:
  <D.7140>:
  paio_remove (acb);
  return;
}



;; Function paio_remove (paio_remove)

paio_remove (struct qemu_paiocb * acb)
{
  struct qemu_paiocb * * pacb;
  struct qemu_paiocb * D.7118;
  const char * restrict D.7115;
  struct FILE * restrict stderr.70;
  struct _IO_FILE * stderr.69;
  struct qemu_paiocb * D.7110;
  struct PosixAioState * posix_aio_state.68;

  posix_aio_state.68 = posix_aio_state;
  pacb = &posix_aio_state.68->first_aio;
  <D.7108>:
  D.7110 = *pacb;
  if (D.7110 == 0B) goto <D.7111>; else goto <D.7112>;
  <D.7111>:
  stderr.69 = stderr;
  stderr.70 = (struct FILE * restrict) stderr.69;
  D.7115 = (const char * restrict) "paio_remove: aio request not found!\n";
  __builtin_fwrite (D.7115, 1, 36, stderr.70);
  goto <D.7107>;
  <D.7112>:
  D.7110 = *pacb;
  if (D.7110 == acb) goto <D.7116>; else goto <D.7117>;
  <D.7116>:
  D.7118 = acb->next;
  *pacb = D.7118;
  qemu_aio_release (acb);
  goto <D.7107>;
  <D.7117>:
  D.7110 = *pacb;
  pacb = &D.7110->next;
  goto <D.7108>;
  <D.7107>:
  return;
}



;; Function qemu_paio_submit (qemu_paio_submit)

qemu_paio_submit (struct qemu_paiocb * aiocb)
{
  struct qemu_paiocb * * D.7028;
  struct qemu_paiocb * * D.7027;
  int max_threads.61;
  int cur_threads.60;
  int idle_threads.59;

  aiocb->ret = -115;
  aiocb->active = 0;
  mutex_lock (&lock);
  idle_threads.59 = idle_threads;
  if (idle_threads.59 == 0) goto <D.7021>; else goto <D.7022>;
  <D.7021>:
  cur_threads.60 = cur_threads;
  max_threads.61 = max_threads;
  if (cur_threads.60 < max_threads.61) goto <D.7025>; else goto <D.7026>;
  <D.7025>:
  spawn_thread ();
  <D.7026>:
  <D.7022>:
  aiocb->node.tqe_next = 0B;
  D.7027 = request_list.tqh_last;
  aiocb->node.tqe_prev = D.7027;
  D.7027 = request_list.tqh_last;
  *D.7027 = aiocb;
  D.7028 = &aiocb->node.tqe_next;
  request_list.tqh_last = D.7028;
  mutex_unlock (&lock);
  cond_signal (&cond);
  return;
}



;; Function spawn_thread (spawn_thread)

spawn_thread ()
{
  struct sigset_t oldset;
  struct sigset_t set;
  int D.7014;
  const struct sigset_t * restrict oldset.58;
  int D.7010;
  const struct sigset_t * restrict set.57;
  int D.7006;
  int idle_threads.56;
  int idle_threads.55;
  int cur_threads.54;
  int cur_threads.53;

  cur_threads.53 = cur_threads;
  cur_threads.54 = cur_threads.53 + 1;
  cur_threads = cur_threads.54;
  idle_threads.55 = idle_threads;
  idle_threads.56 = idle_threads.55 + 1;
  idle_threads = idle_threads.56;
  D.7006 = sigfillset (&set);
  if (D.7006 != 0) goto <D.7007>; else goto <D.7008>;
  <D.7007>:
  die (&"sigfillset"[0]);
  <D.7008>:
  set.57 = (const struct sigset_t * restrict) &set;
  D.7010 = sigprocmask (2, set.57, &oldset);
  if (D.7010 != 0) goto <D.7011>; else goto <D.7012>;
  <D.7011>:
  die (&"sigprocmask"[0]);
  <D.7012>:
  thread_create (&thread_id, &attr, aio_thread, 0B);
  oldset.58 = (const struct sigset_t * restrict) &oldset;
  D.7014 = sigprocmask (2, oldset.58, 0B);
  if (D.7014 != 0) goto <D.7015>; else goto <D.7016>;
  <D.7015>:
  die (&"sigprocmask restore"[0]);
  <D.7016>:
  return;
}



;; Function thread_create (thread_create)

thread_create (pthread_t * thread, union pthread_attr_t * attr, void * (*<T5ff>) (void *) start_routine, void * arg)
{
  int ret;
  int ret.30;
  const union pthread_attr_t * restrict attr.29;

  attr.29 = (const union pthread_attr_t * restrict) attr;
  ret.30 = pthread_create (thread, attr.29, start_routine, arg);
  ret = ret.30;
  if (ret != 0) goto <D.6777>; else goto <D.6778>;
  <D.6777>:
  die2 (ret, &"pthread_create"[0]);
  <D.6778>:
  return;
}



;; Function die (die)

die (const char * what)
{
  int D.6731;
  int * D.6730;

  D.6730 = __errno_location ();
  D.6731 = *D.6730;
  die2 (D.6731, what);
  return;
}



;; Function aio_thread (aio_thread)

aio_thread (void * unused)
{
  struct timespec ts;
  struct qemu_timeval tv;
  size_t ret;
  struct qemu_paiocb * aiocb;
  pid_t pid;
  void * D.6996;
  int cur_threads.52;
  int cur_threads.51;
  int D.6991;
  int D.6990;
  int idle_threads.50;
  ssize_t ret.49;
  struct FILE * restrict stderr.48;
  struct _IO_FILE * stderr.47;
  const char * restrict D.6985;
  size_t ret.46;
  size_t ret.45;
  size_t ret.44;
  int D.6981;
  int D.6980;
  int idle_threads.43;
  int idle_threads.42;
  struct qemu_paiocb * * D.6976;
  struct qemu_paiocb * D.6973;
  _Bool D.6971;
  _Bool D.6970;
  _Bool D.6969;
  struct qemu_paiocb * D.6968;
  int D.6967;
  long int D.6966;
  __time_t D.6965;
  struct timeval * restrict tv.41;
  __pid_t pid.40;

  pid.40 = getpid ();
  pid = pid.40;
  <D.6962>:
  ret = 0;
  tv.41 = (struct timeval * restrict) &tv;
  gettimeofday (tv.41, 0B);
  D.6965 = tv.tv_sec;
  D.6966 = D.6965 + 10;
  ts.tv_sec = D.6966;
  ts.tv_nsec = 0;
  mutex_lock (&lock);
  goto <D.6953>;
  <D.6952>:
  D.6967 = cond_timedwait (&cond, &lock, &ts);
  ret = (size_t) D.6967;
  <D.6953>:
  D.6968 = request_list.tqh_first;
  D.6969 = D.6968 == 0B;
  D.6970 = ret != 110;
  D.6971 = D.6969 && D.6970;
  if (D.6971 != 0) goto <D.6952>; else goto <D.6954>;
  <D.6954>:
  D.6968 = request_list.tqh_first;
  if (D.6968 == 0B) goto <D.6955>; else goto <D.6972>;
  <D.6972>:
  aiocb = request_list.tqh_first;
  D.6973 = aiocb->node.tqe_next;
  if (D.6973 != 0B) goto <D.6974>; else goto <D.6975>;
  <D.6974>:
  D.6973 = aiocb->node.tqe_next;
  D.6976 = aiocb->node.tqe_prev;
  D.6973->node.tqe_prev = D.6976;
  goto <D.6977>;
  <D.6975>:
  D.6976 = aiocb->node.tqe_prev;
  request_list.tqh_last = D.6976;
  <D.6977>:
  D.6976 = aiocb->node.tqe_prev;
  D.6973 = aiocb->node.tqe_next;
  *D.6976 = D.6973;
  aiocb->active = 1;
  idle_threads.42 = idle_threads;
  idle_threads.43 = idle_threads.42 + -1;
  idle_threads = idle_threads.43;
  mutex_unlock (&lock);
  D.6980 = aiocb->aio_type;
  D.6981 = D.6980 & 15;
  switch (D.6981) <default: <D.6961>, case 1: <D.6956>, case 2: <D.6957>, case 4: <D.6960>, case 8: <D.6959>>
  <D.6956>:
  <D.6957>:
  ret.44 = handle_aiocb_rw (aiocb);
  ret = ret.44;
  goto <D.6958>;
  <D.6959>:
  ret.45 = handle_aiocb_flush (aiocb);
  ret = ret.45;
  goto <D.6958>;
  <D.6960>:
  ret.46 = handle_aiocb_ioctl (aiocb);
  ret = ret.46;
  goto <D.6958>;
  <D.6961>:
  D.6980 = aiocb->aio_type;
  D.6985 = (const char * restrict) "invalid aio request (0x%x)\n";
  stderr.47 = stderr;
  stderr.48 = (struct FILE * restrict) stderr.47;
  fprintf (stderr.48, D.6985, D.6980);
  ret = 0x0ffffffea;
  <D.6958>:
  mutex_lock (&lock);
  ret.49 = (ssize_t) ret;
  aiocb->ret = ret.49;
  idle_threads.42 = idle_threads;
  idle_threads.50 = idle_threads.42 + 1;
  idle_threads = idle_threads.50;
  mutex_unlock (&lock);
  D.6990 = aiocb->ev_signo;
  D.6991 = kill (pid, D.6990);
  if (D.6991 != 0) goto <D.6992>; else goto <D.6993>;
  <D.6992>:
  die (&"kill failed"[0]);
  <D.6993>:
  goto <D.6962>;
  <D.6955>:
  idle_threads.42 = idle_threads;
  idle_threads.43 = idle_threads.42 + -1;
  idle_threads = idle_threads.43;
  cur_threads.51 = cur_threads;
  cur_threads.52 = cur_threads.51 + -1;
  cur_threads = cur_threads.52;
  mutex_unlock (&lock);
  D.6996 = 0B;
  goto <D.8931>;
  <D.8931>:
  return D.6996;
}



;; Function cond_timedwait (cond_timedwait)

cond_timedwait (union pthread_cond_t * cond, union pthread_mutex_t * mutex, struct timespec * ts)
{
  int ret;
  int D.6759;
  _Bool D.6756;
  _Bool D.6755;
  _Bool D.6754;
  int ret.27;
  const struct timespec * restrict ts.26;

  ts.26 = (const struct timespec * restrict) ts;
  ret.27 = pthread_cond_timedwait (cond, mutex, ts.26);
  ret = ret.27;
  D.6754 = ret != 0;
  D.6755 = ret != 110;
  D.6756 = D.6754 && D.6755;
  if (D.6756 != 0) goto <D.6757>; else goto <D.6758>;
  <D.6757>:
  die2 (ret, &"pthread_cond_timedwait"[0]);
  <D.6758>:
  D.6759 = ret;
  goto <D.8932>;
  <D.8932>:
  return D.6759;
}



;; Function handle_aiocb_rw (handle_aiocb_rw)

handle_aiocb_rw (struct qemu_paiocb * aiocb)
{
  int i;
  size_t copy;
  size_t count;
  char * p;
  int i;
  char * p;
  char * buf;
  size_t nbytes;
  _Bool D.6943;
  _Bool D.6942;
  _Bool D.6941;
  void * D.6940;
  size_t D.6937;
  struct iovec * D.6936;
  unsigned int D.6935;
  unsigned int i.39;
  size_t nbytes.38;
  void * D.6930;
  size_t D.6929;
  struct iovec * D.6928;
  unsigned int D.6927;
  unsigned int i.37;
  int D.6923;
  void * D.6922;
  size_t D.6917;
  size_t nbytes.36;
  int preadv_present.35;
  size_t D.6912;
  char * D.6911;
  void * D.6910;
  struct iovec * D.6909;
  size_t D.6908;
  int D.6905;
  int D.6902;
  int D.6901;

  D.6901 = aiocb->aio_type;
  D.6902 = D.6901 & 4096;
  if (D.6902 == 0) goto <D.6903>; else goto <D.6904>;
  <D.6903>:
  D.6905 = aiocb->aio_niov;
  if (D.6905 == 1) goto <D.6906>; else goto <D.6907>;
  <D.6906>:
  D.6909 = aiocb->D.6689.aio_iov;
  D.6910 = D.6909->iov_base;
  D.6911 = (char *) D.6910;
  D.6912 = handle_aiocb_rw_linear (aiocb, D.6911);
  D.6908 = D.6912;
  goto <D.8933>;
  <D.6907>:
  preadv_present.35 = preadv_present;
  if (preadv_present.35 != 0) goto <D.6914>; else goto <D.6915>;
  <D.6914>:
  nbytes.36 = handle_aiocb_rw_vector (aiocb);
  nbytes = nbytes.36;
  D.6917 = aiocb->aio_nbytes;
  if (D.6917 == nbytes) goto <D.6918>; else goto <D.6919>;
  <D.6918>:
  D.6908 = nbytes;
  goto <D.8933>;
  <D.6919>:
  goto <D.6921>;
  <D.6920>:
  D.6908 = nbytes;
  goto <D.8933>;
  <D.6921>:
  preadv_present = 0;
  <D.6915>:
  <D.6904>:
  D.6917 = aiocb->aio_nbytes;
  D.6922 = qemu_memalign (512, D.6917);
  buf = (char *) D.6922;
  D.6901 = aiocb->aio_type;
  D.6923 = D.6901 & 2;
  if (D.6923 != 0) goto <D.6924>; else goto <D.6925>;
  <D.6924>:
  p = buf;
  i = 0;
  goto <D.6892>;
  <D.6891>:
  D.6909 = aiocb->D.6689.aio_iov;
  i.37 = (unsigned int) i;
  D.6927 = i.37 * 8;
  D.6928 = D.6909 + D.6927;
  D.6929 = D.6928->iov_len;
  D.6909 = aiocb->D.6689.aio_iov;
  i.37 = (unsigned int) i;
  D.6927 = i.37 * 8;
  D.6928 = D.6909 + D.6927;
  D.6930 = D.6928->iov_base;
  memcpy (p, D.6930, D.6929);
  D.6909 = aiocb->D.6689.aio_iov;
  i.37 = (unsigned int) i;
  D.6927 = i.37 * 8;
  D.6928 = D.6909 + D.6927;
  D.6929 = D.6928->iov_len;
  p = p + D.6929;
  i = i + 1;
  <D.6892>:
  D.6905 = aiocb->aio_niov;
  if (D.6905 > i) goto <D.6891>; else goto <D.6893>;
  <D.6893>:
  <D.6925>:
  nbytes.38 = handle_aiocb_rw_linear (aiocb, buf);
  nbytes = nbytes.38;
  D.6901 = aiocb->aio_type;
  D.6923 = D.6901 & 2;
  if (D.6923 == 0) goto <D.6932>; else goto <D.6933>;
  <D.6932>:
  p = buf;
  count = aiocb->aio_nbytes;
  i = 0;
  goto <D.6899>;
  <D.6898>:
  copy = count;
  D.6909 = aiocb->D.6689.aio_iov;
  i.39 = (unsigned int) i;
  D.6935 = i.39 * 8;
  D.6936 = D.6909 + D.6935;
  D.6937 = D.6936->iov_len;
  if (D.6937 < copy) goto <D.6938>; else goto <D.6939>;
  <D.6938>:
  D.6909 = aiocb->D.6689.aio_iov;
  i.39 = (unsigned int) i;
  D.6935 = i.39 * 8;
  D.6936 = D.6909 + D.6935;
  copy = D.6936->iov_len;
  <D.6939>:
  D.6909 = aiocb->D.6689.aio_iov;
  i.39 = (unsigned int) i;
  D.6935 = i.39 * 8;
  D.6936 = D.6909 + D.6935;
  D.6940 = D.6936->iov_base;
  memcpy (D.6940, p, copy);
  p = p + copy;
  count = count - copy;
  i = i + 1;
  <D.6899>:
  D.6905 = aiocb->aio_niov;
  D.6941 = D.6905 > i;
  D.6942 = count != 0;
  D.6943 = D.6941 && D.6942;
  if (D.6943 != 0) goto <D.6898>; else goto <D.6900>;
  <D.6900>:
  <D.6933>:
  qemu_vfree (buf);
  D.6908 = nbytes;
  goto <D.8933>;
  <D.8933>:
  return D.6908;
}



;; Function handle_aiocb_rw_vector (handle_aiocb_rw_vector)

handle_aiocb_rw_vector (struct qemu_paiocb * aiocb)
{
  ssize_t len;
  size_t offset;
  int D.6849;
  size_t D.6848;
  int D.6845;
  int * D.6844;
  ssize_t len.34;
  ssize_t len.33;
  int D.6839;
  struct iovec * D.6838;
  int D.6837;
  off_t D.6836;
  off_t D.6835;
  off_t D.6834;
  int D.6831;
  int D.6830;

  offset = 0;
  <D.6828>:
  D.6830 = aiocb->aio_type;
  D.6831 = D.6830 & 2;
  if (D.6831 != 0) goto <D.6832>; else goto <D.6833>;
  <D.6832>:
  D.6834 = aiocb->aio_offset;
  D.6835 = (off_t) offset;
  D.6836 = D.6834 + D.6835;
  D.6837 = aiocb->aio_niov;
  D.6838 = aiocb->D.6689.aio_iov;
  D.6839 = aiocb->aio_fildes;
  len.33 = qemu_pwritev (D.6839, D.6838, D.6837, D.6836);
  len = len.33;
  goto <D.6841>;
  <D.6833>:
  D.6834 = aiocb->aio_offset;
  D.6835 = (off_t) offset;
  D.6836 = D.6834 + D.6835;
  D.6837 = aiocb->aio_niov;
  D.6838 = aiocb->D.6689.aio_iov;
  D.6839 = aiocb->aio_fildes;
  len.34 = qemu_preadv (D.6839, D.6838, D.6837, D.6836);
  len = len.34;
  <D.6841>:
  if (len == -1) goto <D.6843>; else goto <D.6829>;
  <D.6843>:
  D.6844 = __errno_location ();
  D.6845 = *D.6844;
  if (D.6845 == 4) goto <D.6828>; else goto <D.6829>;
  <D.6829>:
  if (len == -1) goto <D.6846>; else goto <D.6847>;
  <D.6846>:
  D.6844 = __errno_location ();
  D.6845 = *D.6844;
  D.6849 = -D.6845;
  D.6848 = (size_t) D.6849;
  goto <D.8934>;
  <D.6847>:
  D.6848 = (size_t) len;
  goto <D.8934>;
  <D.8934>:
  return D.6848;
}



;; Function qemu_pwritev (qemu_pwritev)

qemu_pwritev (int fd, const struct iovec * iov, int nr_iov, off_t offset)
{
  ssize_t D.6822;
  __off_t D.6821;
  ssize_t D.6820;

  D.6821 = (__off_t) offset;
  D.6822 = pwritev (fd, iov, nr_iov, D.6821);
  D.6820 = D.6822;
  goto <D.8935>;
  <D.8935>:
  return D.6820;
}



;; Function qemu_preadv (qemu_preadv)

qemu_preadv (int fd, const struct iovec * iov, int nr_iov, off_t offset)
{
  ssize_t D.6813;
  __off_t D.6812;
  ssize_t D.6811;

  D.6812 = (__off_t) offset;
  D.6813 = preadv (fd, iov, nr_iov, D.6812);
  D.6811 = D.6813;
  goto <D.8936>;
  <D.8936>:
  return D.6811;
}



;; Function handle_aiocb_rw_linear (handle_aiocb_rw_linear)

handle_aiocb_rw_linear (struct qemu_paiocb * aiocb, char * buf)
{
  size_t len;
  size_t offset;
  size_t D.6883;
  int D.6881;
  int D.6877;
  int * D.6876;
  ssize_t D.6873;
  void * D.6872;
  ssize_t D.6870;
  int D.6869;
  const void * D.6868;
  size_t D.6867;
  size_t D.6866;
  off_t D.6865;
  off_t D.6864;
  off_t D.6863;
  int D.6860;
  int D.6859;

  offset = 0;
  goto <D.6856>;
  <D.6858>:
  D.6859 = aiocb->aio_type;
  D.6860 = D.6859 & 2;
  if (D.6860 != 0) goto <D.6861>; else goto <D.6862>;
  <D.6861>:
  D.6863 = aiocb->aio_offset;
  D.6864 = (off_t) offset;
  D.6865 = D.6863 + D.6864;
  D.6866 = aiocb->aio_nbytes;
  D.6867 = D.6866 - offset;
  D.6868 = buf + offset;
  D.6869 = aiocb->aio_fildes;
  D.6870 = pwrite (D.6869, D.6868, D.6867, D.6865);
  len = (size_t) D.6870;
  goto <D.6871>;
  <D.6862>:
  D.6863 = aiocb->aio_offset;
  D.6864 = (off_t) offset;
  D.6865 = D.6863 + D.6864;
  D.6866 = aiocb->aio_nbytes;
  D.6867 = D.6866 - offset;
  D.6872 = buf + offset;
  D.6869 = aiocb->aio_fildes;
  D.6873 = pread (D.6869, D.6872, D.6867, D.6865);
  len = (size_t) D.6873;
  <D.6871>:
  if (len == 0x0ffffffff) goto <D.6875>; else goto <D.6874>;
  <D.6875>:
  D.6876 = __errno_location ();
  D.6877 = *D.6876;
  if (D.6877 == 4) goto <D.6878>; else goto <D.6874>;
  <D.6878>:
  // predicted unlikely by continue predictor.
  goto <D.6856>;
  <D.6874>:
  if (len == 0x0ffffffff) goto <D.6879>; else goto <D.6880>;
  <D.6879>:
  D.6876 = __errno_location ();
  D.6877 = *D.6876;
  D.6881 = -D.6877;
  offset = (size_t) D.6881;
  goto <D.6857>;
  <D.6880>:
  if (len == 0) goto <D.6857>; else goto <D.6882>;
  <D.6882>:
  offset = offset + len;
  <D.6856>:
  D.6866 = aiocb->aio_nbytes;
  if (D.6866 > offset) goto <D.6858>; else goto <D.6857>;
  <D.6857>:
  D.6883 = offset;
  goto <D.8937>;
  <D.8937>:
  return D.6883;
}



;; Function handle_aiocb_flush (handle_aiocb_flush)

handle_aiocb_flush (struct qemu_paiocb * aiocb)
{
  int ret;
  int D.6804;
  int D.6803;
  int * D.6802;
  size_t D.6801;
  int ret.32;
  int D.6797;

  D.6797 = aiocb->aio_fildes;
  ret.32 = qemu_fdatasync (D.6797);
  ret = ret.32;
  if (ret == -1) goto <D.6799>; else goto <D.6800>;
  <D.6799>:
  D.6802 = __errno_location ();
  D.6803 = *D.6802;
  D.6804 = -D.6803;
  D.6801 = (size_t) D.6804;
  goto <D.8938>;
  <D.6800>:
  D.6801 = 0;
  goto <D.8938>;
  <D.8938>:
  return D.6801;
}



;; Function handle_aiocb_ioctl (handle_aiocb_ioctl)

handle_aiocb_ioctl (struct qemu_paiocb * aiocb)
{
  int ret;
  int D.6792;
  int D.6791;
  int * D.6790;
  size_t D.6789;
  int ret.31;
  int D.6785;
  size_t D.6784;
  void * D.6783;

  D.6783 = aiocb->D.6689.aio_ioctl_buf;
  D.6784 = aiocb->aio_nbytes;
  D.6785 = aiocb->aio_fildes;
  ret.31 = ioctl (D.6785, D.6784, D.6783);
  ret = ret.31;
  if (ret == -1) goto <D.6787>; else goto <D.6788>;
  <D.6787>:
  D.6790 = __errno_location ();
  D.6791 = *D.6790;
  D.6792 = -D.6791;
  D.6789 = (size_t) D.6792;
  goto <D.8939>;
  <D.6788>:
  D.6789 = aiocb->aio_nbytes;
  goto <D.8939>;
  <D.8939>:
  return D.6789;
}



;; Function cond_signal (cond_signal)

cond_signal (union pthread_cond_t * cond)
{
  int ret;
  int ret.28;

  ret.28 = pthread_cond_signal (cond);
  ret = ret.28;
  if (ret != 0) goto <D.6765>; else goto <D.6766>;
  <D.6765>:
  die2 (ret, &"pthread_cond_signal"[0]);
  <D.6766>:
  return;
}



;; Function paio_submit (paio_submit)

paio_submit (struct BlockDriverState * bs, void * aio_ctx, int fd, int64_t sector_num, struct QEMUIOVector * qiov, int nb_sectors, void (*<T122d>) (void *, int) cb, void * opaque, int type)
{
  struct qemu_paiocb * acb;
  struct qemu_paiocb * D.7167;
  struct PosixAioState * posix_aio_state.71;
  int64_t D.7165;
  size_t D.7164;
  int D.7163;
  int D.7162;
  struct iovec * D.7161;
  struct BlockDriverAIOCB * D.7158;
  void * D.7155;

  D.7155 = qemu_aio_get (&raw_aio_pool, bs, cb, opaque);
  acb = (struct qemu_paiocb *) D.7155;
  if (acb == 0B) goto <D.7156>; else goto <D.7157>;
  <D.7156>:
  D.7158 = 0B;
  goto <D.8940>;
  <D.7157>:
  acb->aio_type = type;
  acb->aio_fildes = fd;
  acb->ev_signo = 12;
  if (qiov != 0B) goto <D.7159>; else goto <D.7160>;
  <D.7159>:
  D.7161 = qiov->iov;
  acb->D.6689.aio_iov = D.7161;
  D.7162 = qiov->niov;
  acb->aio_niov = D.7162;
  <D.7160>:
  D.7163 = nb_sectors * 512;
  D.7164 = (size_t) D.7163;
  acb->aio_nbytes = D.7164;
  D.7165 = sector_num * 512;
  acb->aio_offset = D.7165;
  posix_aio_state.71 = posix_aio_state;
  D.7167 = posix_aio_state.71->first_aio;
  acb->next = D.7167;
  posix_aio_state.71 = posix_aio_state;
  posix_aio_state.71->first_aio = acb;
  qemu_paio_submit (acb);
  D.7158 = &acb->common;
  goto <D.8940>;
  <D.8940>:
  return D.7158;
}


