
;; Function paio_init (paio_init)

paio_init ()
{
  int ret;
  int fds[2];
  struct PosixAioState * s;
  struct sigaction act;
  int ret.79;
  int ret.78;
  int D.7210;
  int D.7209;
  int D.7208;
  int D.7207;
  const char * restrict D.7206;
  struct FILE * restrict stderr.77;
  struct _IO_FILE * stderr.76;
  int D.7201;
  const struct sigaction * restrict act.75;
  void * D.7199;
  void * D.7198;
  struct PosixAioState * posix_aio_state.74;

  posix_aio_state.74 = posix_aio_state;
  if (posix_aio_state.74 != 0B) goto <D.7196>; else goto <D.7197>;
  <D.7196>:
  D.7198 = posix_aio_state;
  goto <D.8931>;
  <D.7197>:
  D.7199 = qemu_malloc (12);
  s = (struct PosixAioState *) D.7199;
  sigfillset (&act.sa_mask);
  act.sa_flags = 0;
  act.__sigaction_handler.sa_handler = aio_signal_handler;
  act.75 = (const struct sigaction * restrict) &act;
  sigaction (12, act.75, 0B);
  s->first_aio = 0B;
  D.7201 = pipe (&fds);
  if (D.7201 == -1) goto <D.7202>; else goto <D.7203>;
  <D.7202>:
  stderr.76 = stderr;
  stderr.77 = (struct FILE * restrict) stderr.76;
  D.7206 = (const char * restrict) "failed to create pipe\n";
  __builtin_fwrite (D.7206, 1, 22, stderr.77);
  D.7198 = 0B;
  goto <D.8931>;
  <D.7203>:
  D.7207 = fds[0];
  s->rfd = D.7207;
  D.7208 = fds[1];
  s->wfd = D.7208;
  D.7209 = s->rfd;
  fcntl (D.7209, 4, 2048);
  D.7210 = s->wfd;
  fcntl (D.7210, 4, 2048);
  D.7209 = s->rfd;
  qemu_aio_set_fd_handler (D.7209, posix_aio_read, 0B, posix_aio_flush, s);
  ret.78 = pthread_attr_init (&attr);
  ret = ret.78;
  if (ret != 0) goto <D.7212>; else goto <D.7213>;
  <D.7212>:
  die2 (ret, &"pthread_attr_init"[0]);
  <D.7213>:
  ret.79 = pthread_attr_setdetachstate (&attr, 1);
  ret = ret.79;
  if (ret != 0) goto <D.7215>; else goto <D.7216>;
  <D.7215>:
  die2 (ret, &"pthread_attr_setdetachstate"[0]);
  <D.7216>:
  request_list.tqh_first = 0B;
  request_list.tqh_last = &request_list.tqh_first;
  posix_aio_state = s;
  D.7198 = posix_aio_state;
  goto <D.8931>;
  <D.8931>:
  return D.7198;
}



;; Function die2 (die2)

die2 (int err, const char * what)
{
  struct FILE * restrict stderr.23;
  struct _IO_FILE * stderr.22;
  const char * restrict D.6724;
  char * D.6723;

  D.6723 = strerror (err);
  D.6724 = (const char * restrict) "%s failed: %s\n";
  stderr.22 = stderr;
  stderr.23 = (struct FILE * restrict) stderr.22;
  fprintf (stderr.23, D.6724, what, D.6723);
  abort ();
}



;; Function posix_aio_flush (posix_aio_flush)

posix_aio_flush (void * opaque)
{
  struct PosixAioState * s;
  struct qemu_paiocb * D.7098;
  int D.7097;

  s = (struct PosixAioState *) opaque;
  D.7098 = s->first_aio;
  D.7097 = D.7098 != 0B;
  goto <D.8932>;
  <D.8932>:
  return D.7097;
}



;; Function posix_aio_read (posix_aio_read)

posix_aio_read (void * opaque)
{
  char bytes[16];
  ssize_t len;
  int ret;
  struct qemu_paiocb * * pacb;
  struct qemu_paiocb * acb;
  struct PosixAioState * s;
  void * D.7092;
  void (*<T122d>) (void *, int) D.7091;
  size_t D.7086;
  size_t ret.67;
  ssize_t ret.66;
  struct qemu_paiocb * D.7078;
  int ret.65;
  int D.7069;
  int * D.7068;
  ssize_t len.64;
  int D.7064;

  s = (struct PosixAioState *) opaque;
  <D.7059>:
  D.7064 = s->rfd;
  len.64 = read (D.7064, &bytes, 16);
  len = len.64;
  if (len == -1) goto <D.7066>; else goto <D.7067>;
  <D.7066>:
  D.7068 = __errno_location ();
  D.7069 = *D.7068;
  if (D.7069 == 4) goto <D.7070>; else goto <D.7071>;
  <D.7070>:
  // predicted unlikely by continue predictor.
  goto <D.7057>;
  <D.7071>:
  <D.7067>:
  if (len == 16) goto <D.7072>; else goto <D.7073>;
  <D.7072>:
  // predicted unlikely by continue predictor.
  goto <D.7057>;
  <D.7073>:
  goto <D.7058>;
  <D.7057>:
  goto <D.7059>;
  <D.7058>:
  <D.7063>:
  pacb = &s->first_aio;
  <D.7062>:
  acb = *pacb;
  if (acb == 0B) goto the_end; else goto <D.7074>;
  <D.7074>:
  ret.65 = qemu_paio_error (acb);
  ret = ret.65;
  if (ret == 125) goto <D.7076>; else goto <D.7077>;
  <D.7076>:
  D.7078 = acb->next;
  *pacb = D.7078;
  qemu_aio_release (acb);
  goto <D.7079>;
  <D.7077>:
  if (ret != 115) goto <D.7080>; else goto <D.7081>;
  <D.7080>:
  if (ret == 0) goto <D.7082>; else goto <D.7083>;
  <D.7082>:
  ret.66 = qemu_paio_return (acb);
  ret = ret.66;
  ret.67 = (size_t) ret;
  D.7086 = acb->aio_nbytes;
  if (ret.67 == D.7086) goto <D.7087>; else goto <D.7088>;
  <D.7087>:
  ret = 0;
  goto <D.7089>;
  <D.7088>:
  ret = -22;
  <D.7089>:
  goto <D.7090>;
  <D.7083>:
  ret = -ret;
  <D.7090>:
  D.7078 = acb->next;
  *pacb = D.7078;
  D.7091 = acb->common.cb;
  D.7092 = acb->common.opaque;
  D.7091 (D.7092, ret);
  qemu_aio_release (acb);
  goto <D.7061>;
  <D.7081>:
  pacb = &acb->next;
  <D.7079>:
  goto <D.7062>;
  <D.7061>:
  goto <D.7063>;
  the_end:
  return;
}



;; Function qemu_paio_error (qemu_paio_error)

qemu_paio_error (struct qemu_paiocb * aiocb)
{
  ssize_t ret;
  int D.7047;
  ssize_t ret.63;

  ret.63 = qemu_paio_return (aiocb);
  ret = ret.63;
  if (ret < 0) goto <D.7044>; else goto <D.7045>;
  <D.7044>:
  ret = -ret;
  goto <D.7046>;
  <D.7045>:
  ret = 0;
  <D.7046>:
  D.7047 = ret;
  goto <D.8933>;
  <D.8933>:
  return D.7047;
}



;; Function qemu_paio_return (qemu_paio_return)

qemu_paio_return (struct qemu_paiocb * aiocb)
{
  ssize_t ret;
  ssize_t D.7038;

  mutex_lock (&lock);
  ret = aiocb->ret;
  mutex_unlock (&lock);
  D.7038 = ret;
  goto <D.8934>;
  <D.8934>:
  return D.7038;
}



;; Function mutex_lock (mutex_lock)

mutex_lock (union pthread_mutex_t * mutex)
{
  int ret;
  int ret.24;

  ret.24 = pthread_mutex_lock (mutex);
  ret = ret.24;
  if (ret != 0) goto <D.6737>; else goto <D.6738>;
  <D.6737>:
  die2 (ret, &"pthread_mutex_lock"[0]);
  <D.6738>:
  return;
}



;; Function mutex_unlock (mutex_unlock)

mutex_unlock (union pthread_mutex_t * mutex)
{
  int ret;
  int ret.25;

  ret.25 = pthread_mutex_unlock (mutex);
  ret = ret.25;
  if (ret != 0) goto <D.6744>; else goto <D.6745>;
  <D.6744>:
  die2 (ret, &"pthread_mutex_unlock"[0]);
  <D.6745>:
  return;
}



;; Function aio_signal_handler (aio_signal_handler)

aio_signal_handler (int signum)
{
  char byte;
  int D.7107;
  struct PosixAioState * posix_aio_state.68;

  posix_aio_state.68 = posix_aio_state;
  if (posix_aio_state.68 != 0B) goto <D.7105>; else goto <D.7106>;
  <D.7105>:
  byte = 0;
  posix_aio_state.68 = posix_aio_state;
  D.7107 = posix_aio_state.68->wfd;
  write (D.7107, &byte, 1);
  <D.7106>:
  qemu_service_io ();
  return;
}



;; Function paio_ioctl (paio_ioctl)

paio_ioctl (struct BlockDriverState * bs, int fd, long unsigned int req, void * buf, void (*<T122d>) (void *, int) cb, void * opaque)
{
  struct qemu_paiocb * acb;
  struct qemu_paiocb * D.7187;
  struct PosixAioState * posix_aio_state.73;
  struct BlockDriverAIOCB * D.7185;
  void * D.7182;

  D.7182 = qemu_aio_get (&raw_aio_pool, bs, cb, opaque);
  acb = (struct qemu_paiocb *) D.7182;
  if (acb == 0B) goto <D.7183>; else goto <D.7184>;
  <D.7183>:
  D.7185 = 0B;
  goto <D.8935>;
  <D.7184>:
  acb->aio_type = 4;
  acb->aio_fildes = fd;
  acb->ev_signo = 12;
  acb->aio_offset = 0;
  acb->D.6689.aio_ioctl_buf = buf;
  acb->aio_nbytes = req;
  posix_aio_state.73 = posix_aio_state;
  D.7187 = posix_aio_state.73->first_aio;
  acb->next = D.7187;
  posix_aio_state.73 = posix_aio_state;
  posix_aio_state.73->first_aio = acb;
  qemu_paio_submit (acb);
  D.7185 = &acb->common;
  goto <D.8935>;
  <D.8935>:
  return D.7185;
}



;; Function paio_cancel (paio_cancel)

paio_cancel (struct BlockDriverAIOCB * blockacb)
{
  int active;
  struct qemu_paiocb * acb;
  int D.7146;
  ssize_t D.7141;
  struct qemu_paiocb * * D.7138;
  struct qemu_paiocb * D.7135;
  int D.7132;

  acb = (struct qemu_paiocb *) blockacb;
  active = 0;
  mutex_lock (&lock);
  D.7132 = acb->active;
  if (D.7132 == 0) goto <D.7133>; else goto <D.7134>;
  <D.7133>:
  D.7135 = acb->node.tqe_next;
  if (D.7135 != 0B) goto <D.7136>; else goto <D.7137>;
  <D.7136>:
  D.7135 = acb->node.tqe_next;
  D.7138 = acb->node.tqe_prev;
  D.7135->node.tqe_prev = D.7138;
  goto <D.7139>;
  <D.7137>:
  D.7138 = acb->node.tqe_prev;
  request_list.tqh_last = D.7138;
  <D.7139>:
  D.7138 = acb->node.tqe_prev;
  D.7135 = acb->node.tqe_next;
  *D.7138 = D.7135;
  acb->ret = -125;
  goto <D.7140>;
  <D.7134>:
  D.7141 = acb->ret;
  if (D.7141 == -115) goto <D.7142>; else goto <D.7143>;
  <D.7142>:
  active = 1;
  <D.7143>:
  <D.7140>:
  mutex_unlock (&lock);
  if (active != 0) goto <D.7144>; else goto <D.7145>;
  <D.7144>:
  <D.7129>:
  <D.7130>:
  D.7146 = qemu_paio_error (acb);
  if (D.7146 == 115) goto <D.7129>; else goto <D.7131>;
  <D.7131>:
  <D.7145>:
  paio_remove (acb);
  return;
}



;; Function paio_remove (paio_remove)

paio_remove (struct qemu_paiocb * acb)
{
  struct qemu_paiocb * * pacb;
  struct qemu_paiocb * D.7123;
  const char * restrict D.7120;
  struct FILE * restrict stderr.71;
  struct _IO_FILE * stderr.70;
  struct qemu_paiocb * D.7115;
  struct PosixAioState * posix_aio_state.69;

  posix_aio_state.69 = posix_aio_state;
  pacb = &posix_aio_state.69->first_aio;
  <D.7113>:
  D.7115 = *pacb;
  if (D.7115 == 0B) goto <D.7116>; else goto <D.7117>;
  <D.7116>:
  stderr.70 = stderr;
  stderr.71 = (struct FILE * restrict) stderr.70;
  D.7120 = (const char * restrict) "paio_remove: aio request not found!\n";
  __builtin_fwrite (D.7120, 1, 36, stderr.71);
  goto <D.7112>;
  <D.7117>:
  D.7115 = *pacb;
  if (D.7115 == acb) goto <D.7121>; else goto <D.7122>;
  <D.7121>:
  D.7123 = acb->next;
  *pacb = D.7123;
  qemu_aio_release (acb);
  goto <D.7112>;
  <D.7122>:
  D.7115 = *pacb;
  pacb = &D.7115->next;
  goto <D.7113>;
  <D.7112>:
  return;
}



;; Function qemu_paio_submit (qemu_paio_submit)

qemu_paio_submit (struct qemu_paiocb * aiocb)
{
  struct qemu_paiocb * * D.7033;
  struct qemu_paiocb * * D.7032;
  int max_threads.62;
  int cur_threads.61;
  int idle_threads.60;

  aiocb->ret = -115;
  aiocb->active = 0;
  mutex_lock (&lock);
  idle_threads.60 = idle_threads;
  if (idle_threads.60 == 0) goto <D.7026>; else goto <D.7027>;
  <D.7026>:
  cur_threads.61 = cur_threads;
  max_threads.62 = max_threads;
  if (cur_threads.61 < max_threads.62) goto <D.7030>; else goto <D.7031>;
  <D.7030>:
  spawn_thread ();
  <D.7031>:
  <D.7027>:
  aiocb->node.tqe_next = 0B;
  D.7032 = request_list.tqh_last;
  aiocb->node.tqe_prev = D.7032;
  D.7032 = request_list.tqh_last;
  *D.7032 = aiocb;
  D.7033 = &aiocb->node.tqe_next;
  request_list.tqh_last = D.7033;
  mutex_unlock (&lock);
  cond_signal (&cond);
  return;
}



;; Function spawn_thread (spawn_thread)

spawn_thread ()
{
  struct sigset_t oldset;
  struct sigset_t set;
  int D.7019;
  const struct __sigset_t * restrict oldset.59;
  int D.7015;
  const struct __sigset_t * restrict set.58;
  struct __sigset_t * restrict oldset.57;
  int D.7010;
  int idle_threads.56;
  int idle_threads.55;
  int cur_threads.54;
  int cur_threads.53;

  cur_threads.53 = cur_threads;
  cur_threads.54 = cur_threads.53 + 1;
  cur_threads = cur_threads.54;
  idle_threads.55 = idle_threads;
  idle_threads.56 = idle_threads.55 + 1;
  idle_threads = idle_threads.56;
  D.7010 = sigfillset (&set);
  if (D.7010 != 0) goto <D.7011>; else goto <D.7012>;
  <D.7011>:
  die (&"sigfillset"[0]);
  <D.7012>:
  oldset.57 = (struct __sigset_t * restrict) &oldset;
  set.58 = (const struct __sigset_t * restrict) &set;
  D.7015 = pthread_sigmask (2, set.58, oldset.57);
  if (D.7015 != 0) goto <D.7016>; else goto <D.7017>;
  <D.7016>:
  die (&"pthread_sigmask"[0]);
  <D.7017>:
  thread_create (&thread_id, &attr, aio_thread, 0B);
  oldset.59 = (const struct __sigset_t * restrict) &oldset;
  D.7019 = pthread_sigmask (2, oldset.59, 0B);
  if (D.7019 != 0) goto <D.7020>; else goto <D.7021>;
  <D.7020>:
  die (&"pthread_sigmask restore"[0]);
  <D.7021>:
  return;
}



;; Function thread_create (thread_create)

thread_create (pthread_t * thread, union pthread_attr_t * attr, void * (*<T5ff>) (void *) start_routine, void * arg)
{
  int ret;
  int ret.30;
  const union pthread_attr_t * restrict attr.29;

  attr.29 = (const union pthread_attr_t * restrict) attr;
  ret.30 = pthread_create (thread, attr.29, start_routine, arg);
  ret = ret.30;
  if (ret != 0) goto <D.6777>; else goto <D.6778>;
  <D.6777>:
  die2 (ret, &"pthread_create"[0]);
  <D.6778>:
  return;
}



;; Function die (die)

die (const char * what)
{
  int D.6731;
  int * D.6730;

  D.6730 = __errno_location ();
  D.6731 = *D.6730;
  die2 (D.6731, what);
  return;
}



;; Function aio_thread (aio_thread)

aio_thread (void * unused)
{
  struct timespec ts;
  struct qemu_timeval tv;
  size_t ret;
  struct qemu_paiocb * aiocb;
  struct sigset_t set;
  pid_t pid;
  void * D.7000;
  int cur_threads.52;
  int cur_threads.51;
  int D.6995;
  int D.6994;
  int idle_threads.50;
  ssize_t ret.49;
  struct FILE * restrict stderr.48;
  struct _IO_FILE * stderr.47;
  const char * restrict D.6989;
  size_t ret.46;
  size_t ret.45;
  size_t ret.44;
  int D.6985;
  int D.6984;
  int idle_threads.43;
  int idle_threads.42;
  struct qemu_paiocb * * D.6980;
  struct qemu_paiocb * D.6977;
  _Bool D.6975;
  _Bool D.6974;
  _Bool D.6973;
  struct qemu_paiocb * D.6972;
  int D.6971;
  long int D.6970;
  __time_t D.6969;
  struct timeval * restrict tv.41;
  __pid_t pid.40;
  int D.6964;

  D.6964 = sigfillset (&set);
  if (D.6964 != 0) goto <D.6965>; else goto <D.6966>;
  <D.6965>:
  die (&"sigfillset"[0]);
  <D.6966>:
  pid.40 = getpid ();
  pid = pid.40;
  <D.6963>:
  ret = 0;
  tv.41 = (struct timeval * restrict) &tv;
  gettimeofday (tv.41, 0B);
  D.6969 = tv.tv_sec;
  D.6970 = D.6969 + 10;
  ts.tv_sec = D.6970;
  ts.tv_nsec = 0;
  mutex_lock (&lock);
  goto <D.6954>;
  <D.6953>:
  D.6971 = cond_timedwait (&cond, &lock, &ts);
  ret = (size_t) D.6971;
  <D.6954>:
  D.6972 = request_list.tqh_first;
  D.6973 = D.6972 == 0B;
  D.6974 = ret != 110;
  D.6975 = D.6973 && D.6974;
  if (D.6975 != 0) goto <D.6953>; else goto <D.6955>;
  <D.6955>:
  D.6972 = request_list.tqh_first;
  if (D.6972 == 0B) goto <D.6956>; else goto <D.6976>;
  <D.6976>:
  aiocb = request_list.tqh_first;
  D.6977 = aiocb->node.tqe_next;
  if (D.6977 != 0B) goto <D.6978>; else goto <D.6979>;
  <D.6978>:
  D.6977 = aiocb->node.tqe_next;
  D.6980 = aiocb->node.tqe_prev;
  D.6977->node.tqe_prev = D.6980;
  goto <D.6981>;
  <D.6979>:
  D.6980 = aiocb->node.tqe_prev;
  request_list.tqh_last = D.6980;
  <D.6981>:
  D.6980 = aiocb->node.tqe_prev;
  D.6977 = aiocb->node.tqe_next;
  *D.6980 = D.6977;
  aiocb->active = 1;
  idle_threads.42 = idle_threads;
  idle_threads.43 = idle_threads.42 + -1;
  idle_threads = idle_threads.43;
  mutex_unlock (&lock);
  D.6984 = aiocb->aio_type;
  D.6985 = D.6984 & 15;
  switch (D.6985) <default: <D.6962>, case 1: <D.6957>, case 2: <D.6958>, case 4: <D.6961>, case 8: <D.6960>>
  <D.6957>:
  <D.6958>:
  ret.44 = handle_aiocb_rw (aiocb);
  ret = ret.44;
  goto <D.6959>;
  <D.6960>:
  ret.45 = handle_aiocb_flush (aiocb);
  ret = ret.45;
  goto <D.6959>;
  <D.6961>:
  ret.46 = handle_aiocb_ioctl (aiocb);
  ret = ret.46;
  goto <D.6959>;
  <D.6962>:
  D.6984 = aiocb->aio_type;
  D.6989 = (const char * restrict) "invalid aio request (0x%x)\n";
  stderr.47 = stderr;
  stderr.48 = (struct FILE * restrict) stderr.47;
  fprintf (stderr.48, D.6989, D.6984);
  ret = 0x0ffffffea;
  <D.6959>:
  mutex_lock (&lock);
  ret.49 = (ssize_t) ret;
  aiocb->ret = ret.49;
  idle_threads.42 = idle_threads;
  idle_threads.50 = idle_threads.42 + 1;
  idle_threads = idle_threads.50;
  mutex_unlock (&lock);
  D.6994 = aiocb->ev_signo;
  D.6995 = kill (pid, D.6994);
  if (D.6995 != 0) goto <D.6996>; else goto <D.6997>;
  <D.6996>:
  die (&"kill failed"[0]);
  <D.6997>:
  goto <D.6963>;
  <D.6956>:
  idle_threads.42 = idle_threads;
  idle_threads.43 = idle_threads.42 + -1;
  idle_threads = idle_threads.43;
  cur_threads.51 = cur_threads;
  cur_threads.52 = cur_threads.51 + -1;
  cur_threads = cur_threads.52;
  mutex_unlock (&lock);
  D.7000 = 0B;
  goto <D.8936>;
  <D.8936>:
  return D.7000;
}



;; Function cond_timedwait (cond_timedwait)

cond_timedwait (union pthread_cond_t * cond, union pthread_mutex_t * mutex, struct timespec * ts)
{
  int ret;
  int D.6759;
  _Bool D.6756;
  _Bool D.6755;
  _Bool D.6754;
  int ret.27;
  const struct timespec * restrict ts.26;

  ts.26 = (const struct timespec * restrict) ts;
  ret.27 = pthread_cond_timedwait (cond, mutex, ts.26);
  ret = ret.27;
  D.6754 = ret != 0;
  D.6755 = ret != 110;
  D.6756 = D.6754 && D.6755;
  if (D.6756 != 0) goto <D.6757>; else goto <D.6758>;
  <D.6757>:
  die2 (ret, &"pthread_cond_timedwait"[0]);
  <D.6758>:
  D.6759 = ret;
  goto <D.8937>;
  <D.8937>:
  return D.6759;
}



;; Function handle_aiocb_rw (handle_aiocb_rw)

handle_aiocb_rw (struct qemu_paiocb * aiocb)
{
  int i;
  size_t copy;
  size_t count;
  char * p;
  int i;
  char * p;
  char * buf;
  size_t nbytes;
  _Bool D.6943;
  _Bool D.6942;
  _Bool D.6941;
  void * D.6940;
  size_t D.6937;
  struct iovec * D.6936;
  unsigned int D.6935;
  unsigned int i.39;
  size_t nbytes.38;
  void * D.6930;
  size_t D.6929;
  struct iovec * D.6928;
  unsigned int D.6927;
  unsigned int i.37;
  int D.6923;
  void * D.6922;
  size_t D.6917;
  size_t nbytes.36;
  int preadv_present.35;
  size_t D.6912;
  char * D.6911;
  void * D.6910;
  struct iovec * D.6909;
  size_t D.6908;
  int D.6905;
  int D.6902;
  int D.6901;

  D.6901 = aiocb->aio_type;
  D.6902 = D.6901 & 4096;
  if (D.6902 == 0) goto <D.6903>; else goto <D.6904>;
  <D.6903>:
  D.6905 = aiocb->aio_niov;
  if (D.6905 == 1) goto <D.6906>; else goto <D.6907>;
  <D.6906>:
  D.6909 = aiocb->D.6689.aio_iov;
  D.6910 = D.6909->iov_base;
  D.6911 = (char *) D.6910;
  D.6912 = handle_aiocb_rw_linear (aiocb, D.6911);
  D.6908 = D.6912;
  goto <D.8938>;
  <D.6907>:
  preadv_present.35 = preadv_present;
  if (preadv_present.35 != 0) goto <D.6914>; else goto <D.6915>;
  <D.6914>:
  nbytes.36 = handle_aiocb_rw_vector (aiocb);
  nbytes = nbytes.36;
  D.6917 = aiocb->aio_nbytes;
  if (D.6917 == nbytes) goto <D.6918>; else goto <D.6919>;
  <D.6918>:
  D.6908 = nbytes;
  goto <D.8938>;
  <D.6919>:
  goto <D.6921>;
  <D.6920>:
  D.6908 = nbytes;
  goto <D.8938>;
  <D.6921>:
  preadv_present = 0;
  <D.6915>:
  <D.6904>:
  D.6917 = aiocb->aio_nbytes;
  D.6922 = qemu_memalign (512, D.6917);
  buf = (char *) D.6922;
  D.6901 = aiocb->aio_type;
  D.6923 = D.6901 & 2;
  if (D.6923 != 0) goto <D.6924>; else goto <D.6925>;
  <D.6924>:
  p = buf;
  i = 0;
  goto <D.6892>;
  <D.6891>:
  D.6909 = aiocb->D.6689.aio_iov;
  i.37 = (unsigned int) i;
  D.6927 = i.37 * 8;
  D.6928 = D.6909 + D.6927;
  D.6929 = D.6928->iov_len;
  D.6909 = aiocb->D.6689.aio_iov;
  i.37 = (unsigned int) i;
  D.6927 = i.37 * 8;
  D.6928 = D.6909 + D.6927;
  D.6930 = D.6928->iov_base;
  memcpy (p, D.6930, D.6929);
  D.6909 = aiocb->D.6689.aio_iov;
  i.37 = (unsigned int) i;
  D.6927 = i.37 * 8;
  D.6928 = D.6909 + D.6927;
  D.6929 = D.6928->iov_len;
  p = p + D.6929;
  i = i + 1;
  <D.6892>:
  D.6905 = aiocb->aio_niov;
  if (D.6905 > i) goto <D.6891>; else goto <D.6893>;
  <D.6893>:
  <D.6925>:
  nbytes.38 = handle_aiocb_rw_linear (aiocb, buf);
  nbytes = nbytes.38;
  D.6901 = aiocb->aio_type;
  D.6923 = D.6901 & 2;
  if (D.6923 == 0) goto <D.6932>; else goto <D.6933>;
  <D.6932>:
  p = buf;
  count = aiocb->aio_nbytes;
  i = 0;
  goto <D.6899>;
  <D.6898>:
  copy = count;
  D.6909 = aiocb->D.6689.aio_iov;
  i.39 = (unsigned int) i;
  D.6935 = i.39 * 8;
  D.6936 = D.6909 + D.6935;
  D.6937 = D.6936->iov_len;
  if (D.6937 < copy) goto <D.6938>; else goto <D.6939>;
  <D.6938>:
  D.6909 = aiocb->D.6689.aio_iov;
  i.39 = (unsigned int) i;
  D.6935 = i.39 * 8;
  D.6936 = D.6909 + D.6935;
  copy = D.6936->iov_len;
  <D.6939>:
  D.6909 = aiocb->D.6689.aio_iov;
  i.39 = (unsigned int) i;
  D.6935 = i.39 * 8;
  D.6936 = D.6909 + D.6935;
  D.6940 = D.6936->iov_base;
  memcpy (D.6940, p, copy);
  p = p + copy;
  count = count - copy;
  i = i + 1;
  <D.6899>:
  D.6905 = aiocb->aio_niov;
  D.6941 = D.6905 > i;
  D.6942 = count != 0;
  D.6943 = D.6941 && D.6942;
  if (D.6943 != 0) goto <D.6898>; else goto <D.6900>;
  <D.6900>:
  <D.6933>:
  qemu_vfree (buf);
  D.6908 = nbytes;
  goto <D.8938>;
  <D.8938>:
  return D.6908;
}



;; Function handle_aiocb_rw_vector (handle_aiocb_rw_vector)

handle_aiocb_rw_vector (struct qemu_paiocb * aiocb)
{
  ssize_t len;
  size_t offset;
  int D.6849;
  size_t D.6848;
  int D.6845;
  int * D.6844;
  ssize_t len.34;
  ssize_t len.33;
  int D.6839;
  struct iovec * D.6838;
  int D.6837;
  off_t D.6836;
  off_t D.6835;
  off_t D.6834;
  int D.6831;
  int D.6830;

  offset = 0;
  <D.6828>:
  D.6830 = aiocb->aio_type;
  D.6831 = D.6830 & 2;
  if (D.6831 != 0) goto <D.6832>; else goto <D.6833>;
  <D.6832>:
  D.6834 = aiocb->aio_offset;
  D.6835 = (off_t) offset;
  D.6836 = D.6834 + D.6835;
  D.6837 = aiocb->aio_niov;
  D.6838 = aiocb->D.6689.aio_iov;
  D.6839 = aiocb->aio_fildes;
  len.33 = qemu_pwritev (D.6839, D.6838, D.6837, D.6836);
  len = len.33;
  goto <D.6841>;
  <D.6833>:
  D.6834 = aiocb->aio_offset;
  D.6835 = (off_t) offset;
  D.6836 = D.6834 + D.6835;
  D.6837 = aiocb->aio_niov;
  D.6838 = aiocb->D.6689.aio_iov;
  D.6839 = aiocb->aio_fildes;
  len.34 = qemu_preadv (D.6839, D.6838, D.6837, D.6836);
  len = len.34;
  <D.6841>:
  if (len == -1) goto <D.6843>; else goto <D.6829>;
  <D.6843>:
  D.6844 = __errno_location ();
  D.6845 = *D.6844;
  if (D.6845 == 4) goto <D.6828>; else goto <D.6829>;
  <D.6829>:
  if (len == -1) goto <D.6846>; else goto <D.6847>;
  <D.6846>:
  D.6844 = __errno_location ();
  D.6845 = *D.6844;
  D.6849 = -D.6845;
  D.6848 = (size_t) D.6849;
  goto <D.8939>;
  <D.6847>:
  D.6848 = (size_t) len;
  goto <D.8939>;
  <D.8939>:
  return D.6848;
}



;; Function qemu_pwritev (qemu_pwritev)

qemu_pwritev (int fd, const struct iovec * iov, int nr_iov, off_t offset)
{
  ssize_t D.6822;
  __off_t D.6821;
  ssize_t D.6820;

  D.6821 = (__off_t) offset;
  D.6822 = pwritev (fd, iov, nr_iov, D.6821);
  D.6820 = D.6822;
  goto <D.8940>;
  <D.8940>:
  return D.6820;
}



;; Function qemu_preadv (qemu_preadv)

qemu_preadv (int fd, const struct iovec * iov, int nr_iov, off_t offset)
{
  ssize_t D.6813;
  __off_t D.6812;
  ssize_t D.6811;

  D.6812 = (__off_t) offset;
  D.6813 = preadv (fd, iov, nr_iov, D.6812);
  D.6811 = D.6813;
  goto <D.8941>;
  <D.8941>:
  return D.6811;
}



;; Function handle_aiocb_rw_linear (handle_aiocb_rw_linear)

handle_aiocb_rw_linear (struct qemu_paiocb * aiocb, char * buf)
{
  size_t len;
  size_t offset;
  size_t D.6883;
  int D.6881;
  int D.6877;
  int * D.6876;
  ssize_t D.6873;
  void * D.6872;
  ssize_t D.6870;
  int D.6869;
  const void * D.6868;
  size_t D.6867;
  size_t D.6866;
  off_t D.6865;
  off_t D.6864;
  off_t D.6863;
  int D.6860;
  int D.6859;

  offset = 0;
  goto <D.6856>;
  <D.6858>:
  D.6859 = aiocb->aio_type;
  D.6860 = D.6859 & 2;
  if (D.6860 != 0) goto <D.6861>; else goto <D.6862>;
  <D.6861>:
  D.6863 = aiocb->aio_offset;
  D.6864 = (off_t) offset;
  D.6865 = D.6863 + D.6864;
  D.6866 = aiocb->aio_nbytes;
  D.6867 = D.6866 - offset;
  D.6868 = buf + offset;
  D.6869 = aiocb->aio_fildes;
  D.6870 = pwrite (D.6869, D.6868, D.6867, D.6865);
  len = (size_t) D.6870;
  goto <D.6871>;
  <D.6862>:
  D.6863 = aiocb->aio_offset;
  D.6864 = (off_t) offset;
  D.6865 = D.6863 + D.6864;
  D.6866 = aiocb->aio_nbytes;
  D.6867 = D.6866 - offset;
  D.6872 = buf + offset;
  D.6869 = aiocb->aio_fildes;
  D.6873 = pread (D.6869, D.6872, D.6867, D.6865);
  len = (size_t) D.6873;
  <D.6871>:
  if (len == 0x0ffffffff) goto <D.6875>; else goto <D.6874>;
  <D.6875>:
  D.6876 = __errno_location ();
  D.6877 = *D.6876;
  if (D.6877 == 4) goto <D.6878>; else goto <D.6874>;
  <D.6878>:
  // predicted unlikely by continue predictor.
  goto <D.6856>;
  <D.6874>:
  if (len == 0x0ffffffff) goto <D.6879>; else goto <D.6880>;
  <D.6879>:
  D.6876 = __errno_location ();
  D.6877 = *D.6876;
  D.6881 = -D.6877;
  offset = (size_t) D.6881;
  goto <D.6857>;
  <D.6880>:
  if (len == 0) goto <D.6857>; else goto <D.6882>;
  <D.6882>:
  offset = offset + len;
  <D.6856>:
  D.6866 = aiocb->aio_nbytes;
  if (D.6866 > offset) goto <D.6858>; else goto <D.6857>;
  <D.6857>:
  D.6883 = offset;
  goto <D.8942>;
  <D.8942>:
  return D.6883;
}



;; Function handle_aiocb_flush (handle_aiocb_flush)

handle_aiocb_flush (struct qemu_paiocb * aiocb)
{
  int ret;
  int D.6804;
  int D.6803;
  int * D.6802;
  size_t D.6801;
  int ret.32;
  int D.6797;

  D.6797 = aiocb->aio_fildes;
  ret.32 = qemu_fdatasync (D.6797);
  ret = ret.32;
  if (ret == -1) goto <D.6799>; else goto <D.6800>;
  <D.6799>:
  D.6802 = __errno_location ();
  D.6803 = *D.6802;
  D.6804 = -D.6803;
  D.6801 = (size_t) D.6804;
  goto <D.8943>;
  <D.6800>:
  D.6801 = 0;
  goto <D.8943>;
  <D.8943>:
  return D.6801;
}



;; Function handle_aiocb_ioctl (handle_aiocb_ioctl)

handle_aiocb_ioctl (struct qemu_paiocb * aiocb)
{
  int ret;
  int D.6792;
  int D.6791;
  int * D.6790;
  size_t D.6789;
  int ret.31;
  int D.6785;
  size_t D.6784;
  void * D.6783;

  D.6783 = aiocb->D.6689.aio_ioctl_buf;
  D.6784 = aiocb->aio_nbytes;
  D.6785 = aiocb->aio_fildes;
  ret.31 = ioctl (D.6785, D.6784, D.6783);
  ret = ret.31;
  if (ret == -1) goto <D.6787>; else goto <D.6788>;
  <D.6787>:
  D.6790 = __errno_location ();
  D.6791 = *D.6790;
  D.6792 = -D.6791;
  D.6789 = (size_t) D.6792;
  goto <D.8944>;
  <D.6788>:
  D.6789 = aiocb->aio_nbytes;
  goto <D.8944>;
  <D.8944>:
  return D.6789;
}



;; Function cond_signal (cond_signal)

cond_signal (union pthread_cond_t * cond)
{
  int ret;
  int ret.28;

  ret.28 = pthread_cond_signal (cond);
  ret = ret.28;
  if (ret != 0) goto <D.6765>; else goto <D.6766>;
  <D.6765>:
  die2 (ret, &"pthread_cond_signal"[0]);
  <D.6766>:
  return;
}



;; Function paio_submit (paio_submit)

paio_submit (struct BlockDriverState * bs, void * aio_ctx, int fd, int64_t sector_num, struct QEMUIOVector * qiov, int nb_sectors, void (*<T122d>) (void *, int) cb, void * opaque, int type)
{
  struct qemu_paiocb * acb;
  struct qemu_paiocb * D.7172;
  struct PosixAioState * posix_aio_state.72;
  int64_t D.7170;
  size_t D.7169;
  int D.7168;
  int D.7167;
  struct iovec * D.7166;
  struct BlockDriverAIOCB * D.7163;
  void * D.7160;

  D.7160 = qemu_aio_get (&raw_aio_pool, bs, cb, opaque);
  acb = (struct qemu_paiocb *) D.7160;
  if (acb == 0B) goto <D.7161>; else goto <D.7162>;
  <D.7161>:
  D.7163 = 0B;
  goto <D.8945>;
  <D.7162>:
  acb->aio_type = type;
  acb->aio_fildes = fd;
  acb->ev_signo = 12;
  if (qiov != 0B) goto <D.7164>; else goto <D.7165>;
  <D.7164>:
  D.7166 = qiov->iov;
  acb->D.6689.aio_iov = D.7166;
  D.7167 = qiov->niov;
  acb->aio_niov = D.7167;
  <D.7165>:
  D.7168 = nb_sectors * 512;
  D.7169 = (size_t) D.7168;
  acb->aio_nbytes = D.7169;
  D.7170 = sector_num * 512;
  acb->aio_offset = D.7170;
  posix_aio_state.72 = posix_aio_state;
  D.7172 = posix_aio_state.72->first_aio;
  acb->next = D.7172;
  posix_aio_state.72 = posix_aio_state;
  posix_aio_state.72->first_aio = acb;
  qemu_paio_submit (acb);
  D.7163 = &acb->common;
  goto <D.8945>;
  <D.8945>:
  return D.7163;
}


